	extern	spr_1, prmsec, which_pose
	extern	wr_main,rd_main, last_key, wr_aux

	EXTERN	X_Position, Y_Position, Monster_Number		;23-Apr-88  HES
	EXTERN	Present_Pose, Table_Offset_1, Table_Offset_2	;23-Apr-88  HES
	EXTERN	Old_Monster_Number				;23-Apr-88  HES
;	 EXTERN  Table, Y_Offset				 ;23-Apr-88  HES
	EXTERN	rd_aux,wr_aux,rd_main,wr_main			;23-Apr-88  HES
	extern	table_sprite_poses,creature_image_block


	public	modification_cage				;23-Apr-88  HES
	public	animate 					;23-Apr-88  HES
	public	creature_indirect				;kam 4-29-88

	%include macro.inc
	%include secseg.inc					;23-Apr-88  HES
;	 %include mainseg.inc

	seg	graph						;23-Apr-88  HES

animate proc
;
; cage creature amination logic
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	sta	rd_main
	sta	wr_main
	lda	which_pose
	cmp	..old_which_pose
	beq	..continue0
	sta	..old_which_pose
	ldx	monster_number
	jmp	..continue1
..continue0
	ldx	monster_number
	cpx	old_monster_number
	beq	..continue20
	stx	old_monster_number

..continue1
;      this part sets up for a new creature or a change in direction
modification_cage
	lda	table_offset_1,x       ; <<<----SELF MODIFY
	tax
	sta	rd_aux
	lda	creature_image_block,x				;kam 4-29-88
	sta	creature_indirect
	lda	creature_image_block+1,x
	sta	creature_indirect+1
	sta	rd_main
	ldx	#0
	stx	present_pose					;kam 4-30-88
	stx	..temp						;kam 4-29-88

	lda	monster_number
	asl	a
	tax
	sta	rd_aux
	lda	table_sprite_poses,x
	sta	..temp+1
	inx
	lda	table_sprite_poses,x
	sta	..poses
								;kam 4-29-88
..continue20
	sta	wr_aux
	ldy	..temp
	ldx	..temp+1
	cpx	#2
	lbne	..continue2
; here is a two sprite creature
	sta	rd_main 					;23-Apr-88  HES
	lda	x_position
	sta	rd_aux						;23-Apr-88  HES
	clc
	adc	(creature_indirect),y
	sta	spr_1+0 			;final x position
	iny
	sta	rd_main 					;23-Apr-88  HES
	lda	y_position
	sta	rd_aux
	clc
	adc	(creature_indirect),y
	sta	spr_1+1 			;final y position
	iny
	lda	(creature_indirect),y
	sta	spr_1+2 			;color
	iny
	lda	(creature_indirect),y
	sta	spr_1+3 			;flag
	iny
	lda	(creature_indirect),y
	sta	spr_1+4 			;address (low)
	iny
	lda	(creature_indirect),y
	sta	spr_1+5 			;address (high)
	iny

;here is a one sprite creature (if you skip the above)
..continue3
	sta	rd_main 					;23-Apr-88  HES
	lda	x_position
	sta	rd_aux						;23-Apr-88  HES
	clc
	adc	(creature_indirect),y
	sta	spr_1+6 			;final x position
	iny
	sta	rd_main 					;23-Apr-88  HES
	lda	y_position
	sta	rd_aux
	clc
	adc	(creature_indirect),y
	sta	spr_1+7 			;final y position
	iny
	lda	(creature_indirect),y
	sta	spr_1+8 			;color
	iny
	lda	(creature_indirect),y
	sta	spr_1+9 			;flag
	iny
	lda	(creature_indirect),y
	sta	spr_1+10			;address (low)
	iny
	lda	(creature_indirect),y
	sta	spr_1+11			;address (high)
	iny

	sta	wr_main
	sta	rd_main

	inc	present_pose			;cycle thru all poses
	lda	present_pose			;of the creature
	cmp	..poses
	bcc	..continue4
	lda	#0
	sta	present_pose
	ldy	#0
..continue4
	sty	..temp
	stx	..temp+1
	rts

..continue2					;this sets second sprite off
	lda	#0				;in a one sprite creature
	sta	spr_1+3
	jmp	..continue3

;	seg	kensdata

..temp	ds	2
..poses ds	1


..old_which_pose
	db	1


	seg	zpglobal
creature_indirect	ds	2
	seg	graph
animate endproc



	end
