$chip(6502)
$paginate

	extern	column,scan,prim,stamp,fist_pose,fist_table
	extern	wr_aux,wr_main,spr_1,center_body_part_gone
	extern	center_body_part_flag

	public	fist
	%include	secseg.inc
	seg	graph

fist	proc
;
; logic for the fist
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	lda	#$64			;put the fist to the screen
	sta	column
	lda	#$10
	sta	scan
	lda	#55
	sta	prim
	jsr	stamp
	lda	fist_pose
	cmp	#4
	bcc	..fistgood
	lda	#3
..fistgood
	asl	a
	tax
	lda	fist_table,x
	sta	column
	lda	fist_table+1,x
	sta	prim
	jsr	stamp

	lda	fist_pose
	bne	..exit
	lda	center_body_part_gone
	bne	..skip1
	lda	center_body_part_flag
	beq	..exit
..skip1
	lda	#$e6
	sta	wr_aux
	sta	spr_1+21
	sta	wr_main
..exit
	rts

fist	endproc
	end


