

	extern	spr_1,y_init,x_right_1,x_right_2,y_top,y_bottom
	extern	creature_table,monster_number,sprite_position_1
	extern	sprite_position_2,stick,stkval,rd_main,wr_main
	extern	display,page1,workon,erasp,draw, wr_aux
	extern	energy_level, table_rooms ,rd_aux,bot_parts,clock_lo
	extern	game,onevaluememorywrite,table_onevaluememorywrite
	extern	hopfrnt1,hopfrnt2
	extern	hero_death_flag,sprtgam,sprteove,sprtr
	extern	sprtrea,sprtctor,sprtoff,sign_flag

	%include  macro.inc
	%include secseg.inc					;23-Apr-88  HES

	public	options

	seg	graph						;23-Apr-88  HES

options 	proc
;
; options screen logic
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	sta	rd_aux						;kam 4-27-88
	sta	wr_aux

	ldx	#$07						;kam 4-27-88
..loop100							;
	lda	..table_data-1,x				;
	sta	table_onevaluememorywrite-1,x			;
	dex							;
	bne	..loop100					;
	clc
	jsr	onevaluememorywrite				;
								;
	sta	rd_main 					;kam 4-27-88
	sta	wr_main
	lda	#$34			;init x,y parameters
	sta	y_init			;for caged creatures
	lda	#$50
	sta	x_right_1
	lda	#$52
	sta	x_right_2
	lda	#$1a
	sta	y_top
	lda	#$38
	sta	y_bottom

	ldx	#0			;init creature_table for display
	lda	#1
..loop1
	sta	creature_table,x
	inx
	cpx	#6
	bcc	..loop1

	lda	#0			;init for animate
	sta	monster_number
       ; sta	 old_monster_number
       ; sta	 which_pose
	jsr	sprite_position_1

	sta	wr_aux
	lda	#$7e			;hopper init  x,y,color,flag,pointer
	sta	spr_1+12
	lda	#$26
	sta	spr_1+13
	sta	..hop_y
	lda	#$e6
	sta	spr_1+15
	lda	#$03
	sta	spr_1+14
	ldx	#0
	stx	..hop_flag
	inx
	stx	..hop_delay
	lda	#low(hopfrnt1)
	sta	spr_1+16
	lda	#high(hopfrnt1)
	sta	spr_1+17

	lda	#$af			;init the sign sprites x-position
	sta	spr_1+18		;#1
	lda	#$bd
	sta	spr_1+24		;#2
	lda	#$cb
	sta	spr_1+30		;#3


..loop2
	sta	wr_main
	jsr	sprite_position_2	;move creatures, hopper, select game
	sta	wr_aux


	lda	sign_flag		;SIGN ANIMATION
	lbeq	 ..sign3		 ;stop (do not) show the signs
	lda	hero_death_flag
	bne	..endofgame		;hero died, show endofgame sign

..reactoroff				;hero alive, show reactoroff sign
	lda	#high(sprtrea)
	ldx	#high(sprtctor)
	ldy	#high(sprtoff)
	sta	spr_1+23
	stx	spr_1+29
	sty	spr_1+35
	lda	#low(sprtrea)
	ldx	#low(sprtctor)
	ldy	#low(sprtoff)
	sta	spr_1+22
	stx	spr_1+28
	sty	spr_1+34
	jmp	..sign1
..endofgame
	lda	#high(sprtgam)
	ldx	#high(sprteove)
	ldy	#high(sprtr)
	sta	spr_1+23
	stx	spr_1+29
	sty	spr_1+35
	lda	#low(sprtgam)
	ldx	#low(sprteove)
	ldy	#low(sprtr)
	sta	spr_1+22
	stx	spr_1+28
	sty	spr_1+34
..sign1
	lda	#$e6			;set norm flag
	sta	spr_1+21
	sta	spr_1+27
	sta	spr_1+33
	lda	#$07			;color=yellow
	sta	spr_1+20
	sta	spr_1+26
	sta	spr_1+32
	lda	#$81			;sign y-position
	sta	spr_1+19
	sta	spr_1+25
	sta	spr_1+31

	sta	rd_aux
	lda	..dir_flag
	beq	..sign_right
..sign_left
	dec	spr_1+18		;move sign left
	dec	spr_1+24
	dec	spr_1+30
	dec	spr_1+18		;move sign left
	dec	spr_1+24
	dec	spr_1+30
	ldx	#0
	lda	spr_1+30
	cmp	#$a0
	bcc	..sign6
	stx	spr_1+33		;turn off sprite3
..sign5
	lda	spr_1+24
	cmp	#$a1
	bcc	..sign6
	stx	spr_1+27		;turn off sprite2
..sign6
	lda	spr_1+18
	cmp	#$a1
	bcc	..sign7
	stx	spr_1+21		;turn off sprite1
..sign7
	cmp	#$0c
	bcs	..sign2
	stx	..dir_flag		;change direction
..sign2
	jmp	..sign3

..sign_right
	inc	spr_1+18		;move sign right
	inc	spr_1+24
	inc	spr_1+30
	inc	spr_1+18		;move sign right
	inc	spr_1+24
	inc	spr_1+30
	lda	spr_1+30
	cmp	#$a0
	bcc	..sign3
	ldx	#0
	stx	spr_1+33		;turn off third sprite
	lda	spr_1+24
	cmp	#$a1
	bcc	..sign3
	stx	spr_1+27		;turn off second sprite
	lda	spr_1+18
	cmp	#$a1
	bcc	..sign3
	stx	spr_1+21		;turn off first sprite
	cmp	#$b1
	bcc	..sign3
	sta	..dir_flag		;change direction
	sta	wr_main
	sta	rd_main
	dec	sign_flag	       ;0= no more sign showing

..sign3
	sta	rd_main
	sta	wr_aux



	dec	..hop_delay		;hopper animation loop
	bne	..nope
	lda	#$02			;timer delay
	sta	..hop_delay
	lda	..hop_flag
	beq	..up
..down
	inc	..hop_y
	lda	..hop_y
	sta	spr_1+13
	cmp	#$26			;bottom y value
	bne	..nope
	lda	..hop_flag
	eor	#$ff
	sta	..hop_flag
	lda	#low(hopfrnt1)
	sta	spr_1+16
	jmp	..nope
..up
	dec	..hop_y
	lda	..hop_y
	sta	spr_1+13
	cmp	#$21			;top y value
	bne	..nope
	lda	..hop_flag
	eor	#$ff
	sta	..hop_flag
	lda	#low(hopfrnt2)
	sta	spr_1+16
..nope

	sta	wr_main
	jsr	stick
	sta	wr_aux
	lda	stkval
	and	#$0f
	cmp	#4
	beq	..left
	cmp	#8
	beq	..right
	jmp	..sprite
..right
	lda	game
	beq	..sprite
	ldx	#0			;short game
	sta	wr_main
	stx	game
	sta	wr_aux
	lda	#$93
	sta	spr_1+12
	jmp	..sprite
..left
	lda	game
	bne	..sprite
	ldx	#$7e			;long game
	sta	wr_main
	stx	game
	sta	wr_aux
	stx	spr_1+12
..sprite
	sta	rd_main 		;redraw the sprites
	sta	wr_main
	ldx	display
	sta	page1,x
	txa
	eor	#1
	sta	display
	lda	workon
	eor	#$60
	sta	workon

	jsr	erasp						;23-Apr-88  HES
	jsr	draw						;23-Apr-88  HES

	ldx	#28
	stx	..temp+2
..delay
	ldx	#0			;slow down
..loop3
	inx
	bne	..loop3
	dec	..temp+2
	bne	..delay

	lda	stkval			;game selected?
	and	#$c0
	lbeq	..loop2

	sta	rd_main 		;restore memory configuration
	sta	wr_main
	rts



..temp	ds	3
..hop_delay
	ds	1
..hop_flag
	ds	1
..hop_y ds	1
..on_or_off
	ds	1
..table_data
	db	$7d,$7e,$80,$0,$ff,28,40
..dir_flag
	db	255

options endproc
	end
