$CHIP(6502)
$PAGINATE
;$ERRONLY

PrintNumEnable	equ	0

	 %INCLUDE prmseg.inc

	EXTERN	state,dfall

	EXTERN	Src(Page0),Dest(Page0),Ptr(Page0)
	EXTERN	Tmp(Page0),Tmp1(Page0),Tmp2(Page0)
	EXTERN	scan,column,colt,pixt,scanlo,scanhi
	EXTERN	rd_main,rd_aux,wr_main,wr_aux,ram_rd,ram_wr

	EXTERN	NetImageBlock,sp_xpos,sp_ypos,sp_colr,sp_flag,sp_poin
	EXTERN	Stkval
	EXTERN	hero_x,hero_y,HeadFlag,Facing
	EXTERN	Invert_Flag,Invert
	EXTERN	Stamp,Prim,Column,Scan
	EXTERN	jumpto, prmsec

	EXTERN	primlo,primhi,primys,primxs

	 extern   NETFLT1R
	 extern   NETFLT2R
	 extern   NETFLT3R
	 extern   NETFLT4R
	 extern   NETFLT5R
	 extern   NETEMG4R
	 extern   NETOPN1R
	 extern   NETOPN2R
	 extern   NETEMG1L
	 extern   NETEMG2L
	 extern   NETEMG3L
	 extern   NETEMG3R
	 extern   NETEMG1R
	 extern   NETCLO4R
	 extern   NETEMG2R
	 extern   NETCLO1
	 extern   NETCLO0
	 extern   NETCLO4L
	 extern   NETCLO3
	 extern   NETCLO2
	 extern   NETOPNL
	 extern   NETOPNR
	 extern   NETFLT1L
	 extern   NETFLT2L
	 extern   NETFLT3L
	 extern   NETFLT4L
	 extern   NETFLT5L
	 extern   NETEMG4L
	 extern   NETOPN1L
	 extern   NETOPN2L
	 extern   BOTSHOTL
	 extern   BOTSHOTU
	 extern   BOTSHOTR

;	 SEG	 ZPGLOBAL
;Net_X		 ds	 1
;Net_Y		 ds	 1
;NetPhase	 ds	 1
;NetImageIndex	 ds	 1
;NetAngle	 ds	 1
;NetDirection	 ds	 1
;BoltPhase	 ds	 1
;
;Bolt_X  equ	 Net_X
;Bolt_Y  equ	 Net_Y



	SEG	maincode

;	 PUBLIC  NetManager,BoltManager
;	 PUBLIC  NetPhase,BoltPhase
;	 PUBLIC  Net_X,Net_Y,Bolt_X,Bolt_Y
;	PUBLIC	ClrPseudoScreen, ClrScreenEdges
;	PUBLIC	WinningScreen, DisplayStampedStuff



	%If	(PrintNumEnable ne 0)
	 PUBLIC  PrintNum
	%Endif
;
; ASSORTED SUBROUTINES
;
;	EXTERN	 TXTLINE




	SEG	MAINCODE

	%If	(PrintNumEnable ne 0)

printnum	PROC
;
; print a number ("A") @ "X","Y"
;

	sta	..Byte			;Save byte to print.
	stx	..Xcoord		;Save X-coord.
	sty	..Ycoord		;Save Y-coord.
	lda	tmp			;Save the variables we'll use.
	sta	..Oldtmp
	lda	tmp+1
	sta	..Oldtmp+1
	lda	dest
	sta	..OldDest
	lda	dest+1
	sta	..OldDest+1
	lda	ptr
	sta	..OldPtr
	lda	ptr+1
	sta	..OldPtr+1

	lda	ram_rd		;See which memory is enabled
	sta	..Old_rd	; and save this info.
	lda	ram_wr
	sta	..Old_wr

	lda	..Byte			;Get the high nybble...
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	jsr	PrintDigit		;...and print it.

	lda	..Xcoord		;Add to the X-coord.
	clc
	adc	#2
	sta	..Xcoord
	ldy	..Ycoord		;Get the Y-coord.
	lda	..Byte			;Get the low nybble...
	and	#$0f
	jsr	PrintDigit		;...and print it.

	sta	rd_main 	;Restore the banks to the way they were.
	ldx	..Old_rd
	bpl	..label1
	sta	rd_aux
..label1
	sta	wr_main
	ldx	..Old_wr
	bpl	..label2
	sta	wr_aux
..label2

	lda	..OldPtr+1		;Restore variables.
	sta	ptr+1
	lda	..OldPtr
	sta	ptr
	lda	..OldDest+1
	sta	dest+1
	lda	..OldDest
	sta	dest
	lda	..Oldtmp+1
	sta	tmp+1
	lda	..Oldtmp
	sta	tmp

	lda	..Xcoord		;Add to the X-coord.
	clc
	adc	#4
	tax				;Reset X to this new coord.
	lda	..Byte			;Reset Y.
	ldy	..Ycoord

	rts

..Byte		db	0
..Xcoord	db	0
..Ycoord	db	0
..ScanLine	db	0
..Digit 	db	0
..Row		db	0
..Oldtmp	dw	0
..OldDest	dw	0
..OldPtr	dw	0
..Old_rd	db	0
..Old_wr	db	0

PrintDigit
	sty	..ScanLine		;Save the scan line.
	sta	..Digit 		;Save the digit.
	lda	#0			;Init the row count.
	sta	..Row

..Loop
	sta	rd_aux
	ldy	..ScanLine
	lda	scanlo,y		;Set up tmp, Dest,
	sta	tmp			; and Ptr to point
	sta	dest			; to where on the
	sta	ptr			; screen we want
	lda	scanhi,y		; to write.
	ora	#$20
	sta	tmp+1			;tmp -> Screen #1
	ora	#$40
	sta	ptr+1			;Ptr -> Erase Screen.
	and	#$DF
	sta	dest+1			;Dest -> Screen #2.

	ldx	..Digit 		;Find the offset into the
	lda	CharacterIndex,x	; def'n data for this
	clc				; digit and add on the
	adc	..Row			; offset for the row
	adc	..Row			; we're on.
	tax

	sta	wr_aux			;Write out the image
	lda	CharacterDataAux,x	; to Aux memory.
	ldy	..Xcoord
	sta	(tmp),y
	sta	(dest),y
	sta	(ptr),y
	iny
	lda	CharacterDataAux+1,x
	sta	(tmp),y
	sta	(dest),y
	sta	(ptr),y
	dey

	sta	wr_main 		;Write out the image
	lda	CharacterDataMain,x	; to Main memory.
	sta	(tmp),y
	sta	(dest),y
	sta	(ptr),y
	iny
	lda	CharacterDataMain+1,x
	sta	(tmp),y
	sta	(dest),y
	sta	(ptr),y

	inc	..ScanLine		;Goto the next scan line.
	inc	..Row			;Goto the next row.
	ldy	..Row
	cpy	#5			;Are we done with 5 rows?
	bcc	..Loop			;Loop back if no.

	rts


printnum	ENDPROC


	SEG	MAINDATA

CharacterIndex
	db	0,10,20,30,40,50,60,70,80,90
	db	100,110,120,130,140,150

CharacterDataAux
	db	$00,$3f 	;0
	db	$70,$7c
	db	$70,$43
	db	$70,$40
	db	$00,$3f

	db	$00,$03 	;1
	db	$00,$03
	db	$00,$03
	db	$00,$03
	db	$00,$3f

	db	$70,$3f 	;2
	db	$00,$40
	db	$00,$3f
	db	$70,$00
	db	$70,$7f

	db	$70,$3f 	;3
	db	$00,$40
	db	$70,$3f
	db	$00,$40
	db	$70,$3f

	db	$70,$40 	;4
	db	$70,$40
	db	$70,$7f
	db	$00,$40
	db	$00,$40

	db	$70,$7f 	;5
	db	$70,$00
	db	$70,$3f
	db	$00,$40
	db	$70,$3f

	db	$00,$3f 	;6
	db	$70,$00
	db	$70,$3f
	db	$70,$40
	db	$00,$3f

	db	$70,$7f 	;7
	db	$00,$40
	db	$00,$3c
	db	$00,$03
	db	$00,$03

	db	$00,$3f 	;8
	db	$70,$40
	db	$00,$3f
	db	$70,$40
	db	$00,$3f

	db	$00,$3f 	;9
	db	$70,$40
	db	$00,$7f
	db	$00,$40
	db	$00,$40

	db	$00,$3f 	;A
	db	$70,$40
	db	$70,$7f
	db	$70,$40
	db	$70,$40

	db	$70,$3f 	;B
	db	$70,$40
	db	$70,$3f
	db	$70,$40
	db	$70,$3f

	db	$00,$7f 	;C
	db	$70,$00
	db	$70,$00
	db	$70,$00
	db	$00,$7f

	db	$70,$3f 	;D
	db	$70,$40
	db	$70,$40
	db	$70,$40
	db	$70,$3f

	db	$70,$7f 	;E
	db	$70,$00
	db	$70,$7f
	db	$70,$00
	db	$70,$7f

	db	$70,$7f 	;F
	db	$70,$00
	db	$70,$7f
	db	$70,$00
	db	$70,$00

CharacterDataMain
	db	$7f,$00 	;0
	db	$01,$03
	db	$61,$03
	db	$1f,$03
	db	$7f,$00

	db	$60,$00 	;1
	db	$7e,$00
	db	$60,$00
	db	$60,$00
	db	$7e,$00

	db	$7f,$00 	;2
	db	$00,$03
	db	$7f,$00
	db	$01,$00
	db	$7f,$03

	db	$7f,$00 	;3
	db	$00,$03
	db	$7f,$00
	db	$00,$03
	db	$7f,$00

	db	$01,$03 	;4
	db	$01,$03
	db	$7f,$03
	db	$00,$03
	db	$00,$03

	db	$7f,$03 	;5
	db	$01,$00
	db	$7f,$00
	db	$00,$03
	db	$7f,$00

	db	$7e,$00 	;6
	db	$01,$00
	db	$ff,$00
	db	$01,$03
	db	$7f,$00

	db	$7f,$03 	;7
	db	$00,$03
	db	$00,$00
	db	$60,$00
	db	$60,$00

	db	$7f,$00 	;8
	db	$01,$03
	db	$7f,$00
	db	$01,$03
	db	$7f,$00

	db	$7f,$00 	;9
	db	$01,$03
	db	$7f,$03
	db	$00,$03
	db	$00,$03

	db	$7f,$00 	;A
	db	$01,$03
	db	$7f,$03
	db	$01,$03
	db	$01,$03

	db	$7f,$00 	;B
	db	$01,$03
	db	$7f,$00
	db	$01,$03
	db	$7f,$00

	db	$7f,$03 	;C
	db	$01,$00
	db	$01,$00
	db	$01,$00
	db	$7f,$03

	db	$7f,$00 	;D
	db	$01,$03
	db	$01,$03
	db	$01,$03
	db	$7f,$00

	db	$7f,$03 	;E
	db	$01,$00
	db	$7f,$03
	db	$01,$00
	db	$7f,$03

	db	$7f,$03 	;F
	db	$01,$00
	db	$7f,$03
	db	$01,$00
	db	$01,$00

	%Endif

	 END
