;	THIS ROUTINE UPDATES DELAY LOOPS AND EXECUTES IF NECESSARY

	extern	end_game, panel1, headflag, invert_flag, invert
	extern	energy_bars,stick,stkval,setroom_c,setroom_d
	extern	eraseorview, creature_table, monster_number,jumpto
	extern	sprite_position_1, sprite_position_2,prmsec
	extern	clock_lo,clock_hi,energy_level	,panelcopy
	extern	clrscreenedges,spark_level
	extern	sparks_gone_flag,invert_flag,invert,trbck_i,bfall_i
	extern	spark_display,call_sprite_routine,squat_pos,sethero
	extern	go_on ,stat_i,state,walk_pos,bot_standup_i,hero_y
	extern	column,scan,prim,wr_aux,wr_main,stamp,panelcopy
	extern	spark_display,clock_flag,creature_number,creature_flag
	extern	table_main_panel,rd_aux,rd_main,hero_death_flag
	extern	dfall_i,checkunderdroid
	extern	bot_falling_flag,droid_falling_flag,spark_delay
	extern	turnbackflag,call_sprite_routine_once
	extern	old_clock_lo,old_clock_hi,drain_state_3,drain_state
	extern	clock_everything_flag,notimehaschanged

	%include macro.inc
	%include prmseg.inc

	public	timer,sparks_end_2,spark_delay_2
	public	impatient,transform_energy, sparks_end,sparks_end_1

cstat	%macro	immed
	lda	#low(immed)
	sta	state
	lda	#high(immed)
	sta	state+1
	%endm



	SEG	maincode
TIMER	PROC

;	 lda	 sparks_gone_flag
;	 beq	 ..hero 		 ;0=not gone
;	 rts
;..hero
	lda	hero_death_flag 	;0=alive
	beq	..clock
	rts
..clock
			;CLOCK
	dec	clock_delay
	lbne	..continue1		;keep waiting

	lda	#$10			;initialize delay
	sta	clock_delay
	sed				;decrement the clock
	lda	clock_lo
	sta	old_clock_lo
	sec
	sbc	#1
	sta	clock_lo
	bcs	..continue2
	lda	#$59
	sta	clock_lo
	cld
	lda	clock_hi
	sta	old_clock_hi
	beq	..continue3.01		 ;end game
	sed
	sbc	#0
	sta	clock_hi
	jmp	..continue2

..continue3.01
	lda	#0
	sta	clock_lo
..continue3
	lda	#$ff
	sta	hero_death_flag
	sta	sparks_gone_flag
	lda	headflag
	bne	..continue3.15
	pla
	pla
	jmp	sparks_end_2		;droid

..continue3.15
	lda	bot_falling_flag	;bot
	bne	..continue3.16		;falling up or down
	lda	#$ff
	sta	turnbackflag
	rts
..continue3.16
	pla
	pla
	jmp	(state)



..continue2
	cld
	lda	clock_hi		;is time almost up
	bne	..continue1
	lda	clock_lo
	cmp	#$21
	bcs	..continue1
	lda	#128			;force time display
	sta	clock_flag
	lda	#$ff
	sta	clock_everything_flag
	sec
	long	prmsec,panel1		;kam 4-30-88
	lda	#0
	sta	clock_everything_flag
	long	prmsec,clrscreenedges
	sec
	long	prmsec,panelcopy				;kam 4-30-88


			;SPARKS (decrease)
..continue1
	lda	sparks_gone_flag
	bne	..continue5		;we just ran out of sparks
	lda	headflag		;are we a bot or not
	beq	..continue5		;   no
	lda	invert_flag
	ldx	#1			;bot normal
	cmp	#invert
	bne	..continue6
	ldx	#2			;bot upside down
..continue6
	ldy	spark_delay
..continue7
	dey
	dex
	bne	..continue7
	sty	spark_delay
	cpy	#2
	bcs	..continue5		;delay still running

..continue8
	lda	#$fe			;reset spark_delay
	sta	spark_delay
	ldx	spark_delay_2
	dex
	stx	spark_delay_2
	bne	..continue5
	lda	#2
	sta	spark_delay_2
	ldy	spark_level		;decrement the spark level
	dey
	sty	spark_level

	lda	creature_number
	cmp	#3
	beq	..continue8.2		;ray over sparks
	lda	clock_flag
	and	#$c0
	bne	..continue8.2		;time being displayed
	jsr	call_sprite_routine_once
	sec
	long	prmsec,panelcopy
	long	prmsec,spark_display	;show new spark level
..continue8.2
	ldy	spark_level
	bne	..continue5		;sparks left
	sty	transform_energy	;sparks gone, lose transform energy

	lda	#$ff						;kam 5-3-88
	sta	sparks_gone_flag	;sparks gone
	ldx	bot_falling_flag
	bne	..continue5.5
	sta	turnbackflag
;	 jmp	 sparks_end_1
;*******turn into droid ***********
;**********************************

			;SPARKS (INCREASE)

..continue5
	lda	headflag
	bne	..continue5.5
	dec	spark_delay_3
	bne	..continue5.5
	lda	#$fe
	sta	spark_delay_3
	dec	spark_delay_4
	bne	..continue5.5
	lda	#2
	sta	spark_delay_4
	ldx	spark_level
	cpx	#5
	bcs	..continue5.5
	inx
	stx	spark_level


			;ENERGY DRAIN
..continue5.5
	lda	drain_state_3		;FF=no drain
	bmi	..continue11		;not being drained
	lda	#$d0
	sta	drain_delay2
	lda	energy_level		;decrement energy
	sec
	sbc	drain_state_3
	sta	energy_level
	bpl	..backup2
	ldx	#0
	stx	energy_level
..backup2
	lda	#$0
	sta	drain_state		;being drained
	sta	eraseorview
	ldy	#$0a			 ;color to show
	long	prmsec,energy_bars
	lda	headflag
	bne	..continue11
	lda	energy_level
	lbmi	..continue3
	lbeq	..continue3		;*end the game

..continue11
	ldx	drain_delay2
	beq	..continue12
	cpx	#$d1
	bcs	..continue10.5
	dex
	stx	drain_delay2
	jmp	..continue10.5
..continue12
	dex
	stx	drain_delay2
	stx	drain_state		;not draining
	lda	#0
	sta	eraseorview
	ldy	#$09			;color to show energy
	long	prmsec,energy_bars




			;ENERGY GAIN
..continue10.5
	lda	headflag
	bne	..continue13		;skip if bot
	lda	impatient		;is hero impatient
	bne	..continue13
	ldx	power_delay
	beq	..continue14
	dex
	stx	power_delay
	jmp	..continue13
..continue14
	lda	#$18		;was $d0
	sta	power_delay
	ldx	energy_level
	cpx	#100			;maximum energy
	beq	..continue13
	inx
	stx	energy_level
	lda	#0
	sta	eraseorview
	lda	drain_state
	beq	..continue13
	ldy	#$09
	long	prmsec,energy_bars
;	 jsr	 energy_bars
;******** put energy to screen
;*********************************

..continue13

			;TIME DISPLAY
;	 long	 prmsec,stick
	lda	stkval
	and	#$02
	beq	..continue20		;stick not down
	ldx	time_delay
	beq	..continue21		;delay done
	dex
	stx	time_delay
	lda	#$ff
	sta	clock_everything_flag
	jmp	..continue22
..continue21
	lda	clock_flag
	ora	#$40
	sta	clock_flag		;set flag
;	 bne	 ..continue22		 ;time already up
	sec
	long	prmsec,panel1		;put time digits to screen
	lda	notimehaschanged
	bpl	..continue22		;same time,do not redraw
	long	prmsec,clrscreenedges
	jsr	call_sprite_routine
	sec
	long	prmsec,panelcopy				;kam 4-30-88
;	 jsr	 setroom_d		 ;display time
	lda	#$00
	sta	clock_everything_flag
	jmp	..continue22
..continue20
	lda	#40
	sta	time_delay		;reset delay
	lda	clock_flag
	bmi	..continue22
	and	#$40
	beq	..continue22
	and	#0
	sta	clock_flag
	clc					;restore the bottom
	long	prmsec,panel1			;panel to state
	long	prmsec,clrscreenedges		;without the time showing
	sec
	long	prmsec,panelcopy		;kam 4-30-88
	lda	creature_number
	cmp	#3
	beq	..timeskip1		;ray(no sparks)
	lda	headflag
	beq	..timeskip1		;no bot(no sparks)
	long	prmsec,spark_display

..timeskip1
;	 jsr	 setroom_c
..continue22


				;CAGED CREATURES
	ldx	monster_number
	inx
	lda	creature_table,x
	beq	..continue23
	lda	cage_delay
	beq	..continue24
	dec	cage_delay
	jmp	..continue30
..continue24
	lda	#$4
	sta	cage_delay
	long	prmsec,sprite_position_2
	jmp	..continue30
..continue23
	lda	#0
	sta	cage_delay
	long	prmsec,sprite_position_1
..continue30

			;RAY OVER SPARKS

	lda	creature_number
	cmp	#3
	bne	..continue40		;ray not on
	ldy	ray_delay
	beq	..continue31
	dey
	sty	ray_delay
	jmp	..continue40
..continue31
	ldy	#$60
	sty	ray_delay		;reset delay
	lda	#0
	sta	creature_flag
	sta	creature_number 	;reset creature logic
	lda	clock_flag
	bne	..continue40		;clock on
;restamping sparkgenerater
	sta	rd_aux
	lda	table_main_panel+51
	sta	column
	lda	table_main_panel+52
	sta	scan
	sta	rd_main
	lda	#57
	sta	prim


****************************
*    RICH UNRUH PATCH	   *

	lda	scan
	clc
	adc	#$04
	sta	scan

*    RICH UNRUH PATCH	   *
****************************


	long	prmsec,stamp
	sec
	long	prmsec,panelcopy	;redraw the sparkgen
	lda	headflag
	beq	..continue40		;droid(no sparks)
	long	prmsec,spark_display	;draw sparks
..continue40




	rts



;data area for this routine
ray_delay
	db	$60
cage_delay
	db	0
time_delay
	db	$20
clock_delay
	db	$10
spark_delay_2
	db	2
spark_delay_3
	db	$fe
spark_delay_4
	db	2
;spark_level
;	 ds	 1
drain_delay
	db	1
drain_delay2
	db	$30
power_delay
	db	$18
;drain_state
;	 db	 1
transform_energy
	ds	1
;energy_level
;	 db	 52

;clock_lo
;	 db	 0
;clock_hi
;	 db	 $20
;clock_flag
;	 db	 0
impatient
	db	0
;hero_death_flag
;	 db	 0
..buffer	ds	1

	seg   maincode
timer	endproc



sparks_end	proc

	lda	#0			;reset spark stuff
	sta	sparks_gone_flag
	lda	#5
	sta	spark_level

	lda	energy_level		;=< 0  is dead
	lbmi	end_game
	lbeq	end_game

	lda	clock_flag		;time gone
	lbmi	end_game

;clear sparks from screen here
	lda	clock_flag
	bne	..sparkend1
	sta	rd_aux
	lda	table_main_panel+51
	sta	column
	lda	table_main_panel+52
	sta	scan
	sta	rd_main
	lda	#57
	sta	prim


****************************
*    RICH UNRUH PATCH	   *

	lda	scan
	clc
	adc	#$04
	sta	scan

*    RICH UNRUH PATCH	   *
****************************


	long	prmsec,stamp		;stamp sparkgen
	sec
	long	prmsec,panelcopy
..sparkend1

	cstat	stat_i
	jmp	(state) 		;continue game

..kensupsidedown_offset     equ     -33
sparks_end_1				   ;taken from bstat_i

	lda	#$e6
	sta	invert_flag
;	 lda	 squat_pos
;	 bne	 ..set_standup
	lda	hero_y
	sec
	sbc	#..kensupsidedown_offset
	sta	hero_y
	lda	walk_pos
	beq	..set_wide_left
	cmp	#3
	bne	..ok
	lda	#1
	bne	..set_walk_pos
..set_wide_left
	lda	#2
..set_walk_pos
	sta	walk_pos
..ok
	asl	a
	tay
	iny
	jsr	sethero
	jmp	bfall_i 		;fall to ground first
;..set_standup
;	 jmp	 bot_standup_i

sparks_end_2
	jsr	checkunderdroid 		;make sure droid
	cmp	#$20				;doesnt stand on air
	lbne	 sparks_end
	jmp	dfall_i



..return
	jmp (state)

sparks_end	endproc
	end



