$chip(6502)
$paginate
$allpublic

;
;
; This file contains variables that reside in main memory.
; Refer to "mainseg.inc" to determine address ranges of the segments
; used.
;
;

	 %include macro.inc
	 %include mainseg.inc

	 seg	  absvars


	 extern   norm,invert,null

	 extern   droidc_l,droidc_lf,droidc_f,droidc_rf,droidc_r
	 extern   botc_l,botc_lf,botc_f,botc_rf,botc_r
	 extern   xform1a_l,xform2a_l,xform3a_l,xform4_l,xform5_l
	 extern   xform1a_r,xform2a_r,xform3a_r,xform4_r,xform5_r
	 extern   stinger1,stinger2,stinger3
	 extern   stinger4,manowar1,manowar2,manowar3,manowar4

	 extern   leg2_l,leg2_r


	single	workon
	single	prim
	single	scan
	single	column

	double	source
	double	destin

Display 	ds	1

hero_x		ds	1				;23-Apr-88  HES
hero_y		ds	1				;23-Apr-88  HES
headflag	ds	1				;23-Apr-88  HES
facing		ds	1				;23-Apr-88  HES

Net_X		ds	1				;23-Apr-88  HES
Net_Y		ds	1				;23-Apr-88  HES
NetPhase	ds	1				;23-Apr-88  HES
NetImageIndex	ds	1				;23-Apr-88  HES
NetAngle	ds	1				;23-Apr-88  HES
NetDirection	ds	1				;23-Apr-88  HES
BoltPhase	ds	1				;23-Apr-88  HES

Bolt_X	equ	Net_X					;23-Apr-88  HES
Bolt_Y	equ	Net_Y					;23-Apr-88  HES

beastie_flag	  ds	   1

invert_flag	  ds	   1
last_key ds	  1
stkval	 ds	  1
indent	 ds	  1
txtline  ds	  1
max_stick_val	  db	   $ff


;These are Ken's variables:

jump_height_flag ds	1	;used in statertu.asm

Bot_Parts	ds	1
EraseOrView	ds	1
Clock_lo	ds	1
Clock_hi	ds	1
old_clock_lo	ds	1
old_clock_hi	ds	1
Arrow_Position	ds	1
Priority	ds	1

monster_number	db	0
present_pose	ds	1
old_monster_number
		db	1
x_position	ds	1
y_position	ds	1

table_offset_1
	 db	  8,52,36,16,0
table_offset_2
	 db	  8,48,42,24,0

which_pose
	db	0
y_init	ds	1
x_right_1
	ds	1
x_right_2
	ds	1
y_top	ds	1
y_bottom
	ds	1

Energy_Level	ds	1

Creature_Table	ds	7

game	 db	  01

sign_flag	  db	   0
hero_death_flag   db	   0

spark_level	  db	   5
spark_delay	  db	   $fe
sparks_gone_flag  db	   0
creature_number   db	   0
clock_flag	  db	   0

headflip	  db	   0

domain_tab	  ds	   3
grd_pntr	  ds	   2
guard_death	  ds	   1

current_guard_flag	   ds		     1
guard_x 		   ds		     1
guard_y 		   ds		     1

net_adjust_for_hero_movement ds 	     1

soundflag	  ds	   1

drain_state	  db	   1
drain_state_3	  db	   $ff

fuse_command_flag ds	   1
current_fuse_flag ds	   1

fist_table	db	$4b,66,$4f,65,$50,64,$52,63
fist_sprite_table
	db		$5d,$59,$63,$58,$66,$56,$69,$56
fist_animation_flag db	0
fist_delay	db	2
fist_pose	db	4
center_body_part_flag
  db	  0
cbp_delay	db	1
center_body_part_gone
  db	  0
fist_y_pos	db	$28
fist_x_pos	db	$69
current_room_second
  ds	  1
gate_table	ds	4
gate_flag	db	55
gate_room	ds	1
gate_x		db	0
gate_x_table	db	$71,$9b, $6f,$97, $55,$7e, $4e,$63, $55,$7c
gate_on 	ds	5

bot_falling_flag	db	0
droid_falling_flag	db	0
turnbackflag	db	0

last_seq_index	  ds	   1

room_percent	db	0
clock_everything_flag	db	0

leg_parts_here_table	ds	6
leg_x_position_table	db	$20,$87,$24,$45,$52,$5f
leg_y_position_table	db	124,095,100,123,55,123
leg_offset		ds	1
leg_rooms		db	15,22,34,13,40,7
leg_parts_address	dw	leg2_l
			dw	leg2_r
old_game		ds	1
notimehaschanged	ds	1
stop_checking		ds	1
;
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!! danger will robinson !!!! don't add more than $02 after !!!!
;!!!! "stop_checking".	       it won't work (fit).	      !!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;


	 seg	  more_main_junk



botbod_y_pos	db	$28,$2c,$31,$39,$44,$55,$6c,$88


headlo	db	low( droidc_l)
	db	low( droidc_lf)
	db	low( droidc_f)
	db	low( droidc_rf)
	db	low( droidc_r)
	db	low( botc_l)
	db	low( botc_lf)
	db	low( botc_f)
	db	low( botc_rf)
	db	low( botc_r)
	db	low( xform1a_l)
	db	low( xform2a_l)
	db	low( xform2a_l)
	db	low( xform3a_l)
	db	low( xform4_l)
	db	low( xform5_l)
	db	low( xform1a_r)
	db	low( xform2a_r)
	db	low( xform2a_r)
	db	low( xform3a_r)
	db	low( xform4_r)
	db	low( xform5_r)

headhi	db	high( droidc_l)
	db	high( droidc_lf)
	db	high( droidc_f)
	db	high( droidc_rf)
	db	high( droidc_r)
	db	high( botc_l)
	db	high( botc_lf)
	db	high( botc_f)
	db	high( botc_rf)
	db	high( botc_r)
	db	high( xform1a_l)
	db	high( xform2a_l)
	db	high( xform2a_l)
	db	high( xform3a_l)
	db	high( xform4_l)
	db	high( xform5_l)
	db	high( xform1a_r)
	db	high( xform2a_r)
	db	high( xform2a_r)
	db	high( xform3a_r)
	db	high( xform4_r)
	db	high( xform5_r)

impdat	db	1,3,5,7,0,5,3,1,0,0
stinger_seq
	 dw	  stinger4
	 dw	  stinger3
	 dw	  stinger2
	 dw	  stinger1

manowar_seq
	 dw	  manowar4
	 dw	  manowar3
	 dw	  manowar2
	 dw	  manowar1


	 end
