;	THIS IS USED TO MOVE THE CREATURE SELECTION ARROW LEFT AND RIGHT
;		*** carry clear = main loop
;		*** carry set	= initialize arrow

	public	sarrow	,call_sprite_routine,call_sprite_routine_once

	extern	spr_1	 , erasp, draw, prmsec	,rd_main,wr_main,rd_aux,wr_aux
	extern	display,page1,workon ,arrow
	extern	  table_arrows,arrow_position

	%include  prmseg.inc
	%include  macro.inc
;
;
	SEG	maincode
sarrow	proc
;
; A,X,Y - nothing passed
;
; A,X,Y - scrambled
;


	bcs	..continue1

	tya
	and	#4			;left?
	bne	..move_left
	tya
	and	#8
	lbeq	..exit

; move the arrow right?
	lda	arrow_position
	cmp	#6
	lbeq	..exit
	tax
	inx
	stx	arrow_position
	jmp	..continue1

;move the arrow left?
..move_left
	lda	arrow_position
	lbeq	..exit
	tax
	dex
	stx	arrow_position

..continue1
		;*** move arrow to its new location **********
	sta	wr_aux



	ldy	#11		;for sprite 1 (0-12)
	lda	#high(arrow)
	sta	spr_1,y
	dey
	lda	#low(arrow)
	sta	spr_1,y
	dey
	lda	#$e6
	sta	spr_1,y
	dey
	ldx	#7			;yellow
	lda	arrow_position
	bne	..continue2
	ldx	#0			;black
..continue2
	txa
	sta	spr_1,y
	dey
	lda	arrow_position
	asl	a
	tax
	sta	rd_aux						;kam 4-26-88
	lda	table_arrows,x		;y-pos
	sta	spr_1,y
	inx
	dey
	lda	table_arrows,x		;x-pos
	sta	spr_1,y
	jsr	call_sprite_routine	;display the sprite

..exit
	 ldx	#0
..exit_hold
	 dex
	 bne	..exit_hold
	 rts


sarrow	endproc

call_sprite_routine	proc
	sta	rd_main
	sta	wr_main

	long	prmsec,erasp
	long	prmsec,draw
	ldx	display 			;HES
	sta	page1,x 			;
	txa					;
	eor	#1				;
	sta	display 			;
	lda	workon				;
	eor	#$60				;
	sta	workon				;

call_sprite_routine_once
	long	prmsec,erasp			;
	long	prmsec,draw			;
	ldx	display 			;kam
	sta	page1,x 			;
	txa					;
	eor	#1				;
	sta	display 			;
	lda	workon				;
	eor	#$60				;
	sta	workon				;
	rts
call_sprite_routine	endproc

	end




