	extern	rd_main,wr_main,rd_aux,wr_aux,display,page1
	public	panelcopy
	%include	secseg.inc

	seg	graph
;movedown	 proc
;	 ds	 50
;movedown	 endproc

panelcopy	proc
;
; copy a portion of the panel to/from erase screen and screen1/screen2
;
; A,X,Y,P - nothing passed
;
; A,X,Y,P - scrambled
;


	lda	..panelcopy_data
	sta	..mod20+1		;(0) starting column to copy
	bcc	..panelcopy1
	lda	..panelcopy_data+1
	sta	..mod20+1		;(30) starting column to copy
..panelcopy1
	lda	#2
	sta	..temp4

	sta	rd_main
	sta	wr_main
..loop0
	ldx	display
	sta	page1,x
	txa
	eor	#1
	sta	display
	jsr	..loop1
	dec	..temp4
	bne	..loop0
	rts

..screen1
	ldy	#$1e
	sty	..mod2+1
	sty	..temp2
	rts
..screen2
	ldy	#$3e
	sty	..mod2+1
	sty	..temp2
	rts
..erase
	ldy	#$5e
	sty	..mod1+1
	sty	..temp1
	rts

..loop1
	jsr	..screen1
	cpx	#1
	beq	..next1
	jsr	..screen2
..next1
	jsr	..erase
	ldy	#2
	sty	..temp3
	ldy	#8
..loop2
..mod1	lda	#$ff		;<<<<-----self mod
	clc
	adc	#4
	sta	..mod1+1
	sta	..mod3+2
	sta	..mod9+2
	sta	..mod7+2
	sta	..mod5+2
..mod2	lda	#$ff		;<<<<-----self mod
	adc	#4
	sta	..mod2+1
	sta	..mod4+2
	sta	..mod6+2
	sta	..mod8+2
	sta	..mod10+2
..mod20 ldx	#0

..loop3
	sta	rd_main
	sta	wr_main
..mod3	lda	$aa50,x 	;<<<<-----self mod
..mod4	sta	$bb50,x 	;<<<<-----self mod
..mod7	lda	$ccd0,x 	;<<<<-----self mod
..mod8	sta	$ddd0,x 	;<<<<-----self mod
	sta	rd_aux
	sta	wr_aux
..mod5	lda	$ccd0,x 	;<<<<-----self mod
..mod6	sta	$ddd0,x 	;<<<<-----self mod
..mod9	lda	$cc50,x 	;<<<<-----self mod
..mod10 sta	$dd50,x 	;<<<<-----self mod
	inx
	cpx	#40
	bne	..loop3

	dey
	bne	..loop2

	ldx	..temp1
	inx
	stx	..mod1+1
	ldx	..temp2
	inx
	stx	..mod2+1
	ldy	#8
	dec	..temp3
	beq	..exit
	jmp	..loop2
..exit
	sta	rd_main
	sta	wr_main
	rts

..panelcopy_data
	db	0,30		;this may be changed by outside calls
..temp1 ds	1
..temp2 ds	1
..temp3 ds	1
..temp4 ds	1

panelcopy	endproc
	end
