	extern	column, scan, prim, prmsec, bot_parts
	extern	stamp, secprm, eraseorview
	extern	energy_bars, clock_hi,clock_lo
	EXTERN	table_main_panel, table_digits_position 	;23-Apr-88  HES
	EXTERN	rd_aux,wr_aux,rd_main,wr_main			;23-Apr-88  HES
	extern	room_vector ,creature_number,clock_flag
	extern	old_clock_hi,old_clock_lo,clock_everything_flag
	extern	notimehaschanged

	public	panel1						;23-Apr-88  HES
	%include secseg.inc
	%include macro.inc


	seg	graph
panel1	proc
;	THIS ROUTINE IS CALLED TO PRINT OUT THE MAIN PANEL
;	    ****carry clear = main loop
;		carry set   = time display

	lbcs	..continue4

	ldx	#0			;cage and guages
	lda	#39			;# of parts*3
	sta	..modify1+1
	jsr	..continue1

	lda	clock_flag		;last 20 seconds
	bmi	..continue3

	lda	bot_parts
	cmp	#7
	beq	..continue2		;all parts gotten
;show bot parts
	ldx	#39
	lda	#42
	jsr	..nextlast

	lda	bot_parts
	and	#1
	beq	..next1
	ldx	#42
	lda	#45
	jsr	..nextlast
..next1
	lda	bot_parts
	and	#2
	beq	..next2
	ldx	#45
	lda	#48
	jsr	..nextlast
..next2
	lda	bot_parts
	and	#4
	beq    ..continue3
	ldx	#48
	lda	#51
..nextlast
	sta	..modify1+1
	jsr	..continue1
	jmp	..continue3


;show sparker
..continue2
	ldx	#51
	lda	#54
	sta	..modify1+1
	jsr	..continue1

	lda	creature_number
	cmp	#3
	bne	..continue3		;ray not active
	lda	clock_flag
	bmi	..continue3		;no ray, clock active
	ldx	#54			;put ray over spark generator
	lda	#57
	sta	..modify1+1
	jsr	..continue1

..continue3
	lda	#64			;draw only to erase screen
	sta	eraseorview
	ldy	#9			;display energy
	jsr	energy_bars
;	 long	 secprm,energy_bars_vector
	ldy	#$0c			;display room%
	long	secprm,room_vector
	rts				;exit this routine

..continue1
	sta	rd_aux						;23-Apr-88  HES
	lda	table_main_panel,x
	sta	column
	inx
	lda	table_main_panel,x
	sta	scan
	inx
	lda	table_main_panel,x
	sta	prim
	inx
	txa
	pha
	sta	rd_main 					;23-Apr-88  HES


****************************
*    RICH UNRUH PATCH	   *

	 lda	  scan
	 clc
	 adc	  #$04
	 sta	  scan

*    RICH UNRUH PATCH	   *
****************************

	jsr	stamp
	pla
	tax
..modify1
	cpx	#$ff			;** this value is changed by calling routine
	bne	..continue1
	rts


;**************************************************************
;  this is the routine to display the time
..continue4
	lda	#0
	sta	notimehaschanged
	lda	old_clock_lo
	tax
	and	#$0f
	sta	..old_clock_lo_lo
	txa
	and	#$f0
	sta	..old_clock_lo_hi
	lda	old_clock_hi
	tax
	and	#$0f
	sta	..old_clock_hi_lo
	txa
	and	#$f0
	sta	..old_clock_hi_hi

	lda	#$ff
	bit	clock_everything_flag
	lda	clock_hi
	sta	old_clock_hi
	sta	..temp			;high four bits of numbers(0-9)
	and	#$f0
	bvs	..yes1
	cmp	..old_clock_hi_hi
	beq	..no1
..yes1	lsr	a
	lsr	a
	lsr	a
	lsr	a
	ldx	#0
	jsr	..continue5
..no1	lda	..temp
	and	#$0f			;low four bits of number(0-9)
	bvs	..yes2
	cmp	..old_clock_hi_lo
	beq	..no2
..yes2	ldx	#2
	jsr	..continue5
..no2
	lda	clock_lo
	sta	old_clock_lo
	sta	..temp			;high four bits of numbers(0-9)
	and	#$f0
	bvs	..yes3
	cmp	..old_clock_lo_hi
	beq	..no3
..yes3	lsr	a
	lsr	a
	lsr	a
	lsr	a
	ldx	#4
	jsr	..continue5
..no3	lda	..temp
	and	#$0f			;low four bits of number(0-9)
	bvs	..yes4
	cmp	..old_clock_lo_lo
	beq	..no4
..yes4	ldx	#6
	jsr	..continue5
..no4
	bvc	..exit
	lda	#44			;put colon on screen
	sta	prim
	sta	rd_aux						;23-Apr-88  HES
	ldx	table_digits_position+8
	stx	column
	ldx	table_digits_position+9
	stx	scan
	sta	rd_main 					;23-Apr-88  HES
****************************
*    RICH UNRUH PATCH	   *

	 lda	  scan
	 clc
	 adc	  #$04
	 sta	  scan

*    RICH UNRUH PATCH	   *
****************************
	jsr	stamp
..exit
	rts



..continue5
	clc				;stamp the times digits
	adc	#45
	sta	prim
	sta	rd_aux						;23-Apr-88  HES
	lda	table_digits_position,x
	sta	column
	inx
	lda	table_digits_position,x
	sta	scan
	txa
	pha
	sta	rd_main 					;23-Apr-88  HES
****************************
*    RICH UNRUH PATCH	   *

	 lda	  scan
	 clc
	 adc	  #$04
	 sta	  scan

*    RICH UNRUH PATCH	   *
****************************
	jsr	stamp
	pla
	tax
	inx
	lda	#$ff
	sta	notimehaschanged
	bit	clock_everything_flag
	rts

..temp
	ds	3
..old_clock_lo_lo	ds	1
..old_clock_lo_hi	ds	1
..old_clock_hi_lo	ds	1
..old_clock_hi_hi	ds	1

panel1	endproc
	end

