$Chip(6502)
$Paginate
$AllPublic

**********************************************
*					     *
*		Sprite Data blocks	     *
*					     *
**********************************************

	%include auxseg.inc

	SEG	spdata

erbuff	ds	$80

; Sprite #1

spr_1

sp_xpos db	$40	;x-position 0-79
sp_ypos db	$40	;y-position 0-191
sp_colr db	5	;1 in the high order bit means invert horizontally
sp_flag db	0	;norm=$e6,vert. inv.=$c6, not active=0, end-of-list=1
sp_poin dw	box0

spr_2	db	$40, $70
	db	15,$00
	dw	box0

spr_3	db	48, 64
	db	$81, $00
	dw	box0

spr_4	db	48, 20
	db	12, 00
	dw	box0

spr_5	db	38, 20
	db	11, $00
	dw	box0

spr_6	db	48, 44
	db	10, $00
	dw	box0

spr_7	db	38, 44
	db	 9, $00
	dw	box0

spr_8	db	48, 80
	db	 8, $00
	dw	box0

spr_9	db	$ff, $ff
	db	$ff, 0
	dw	box0

spr_10	db	$ff, $ff
	db	$ff, 0
	dw	box0

spr_11	db	$ff, $ff
	db	$ff, 0
	dw	box0

spr_12	db	$ff, $ff
	db	$ff, 0
	dw	box0

spr_13	db	$ff, $ff
	db	$ff, 0
	dw	box0

spr_14	db	$ff, $ff
	db	$ff, 1
	dw	$ffff

box0	db	7	; size

	db	$7f, $7f
	db	$09, $49
	db	$2d, $6d
	db	$09, $4d
	db	$2d, $5d
	db	$2d, $49
	db	$7f, $7f


;velocity variables for floating sprites
dr1	db	1,2
dr2	db	-1,3
dr3	db	1,2
dr4	db	2,3
dr5	db	-1,-3
dr6	db	-2,1
dr7	db	2,-1
dr8	db	3,-4

	END

