$CHIP(6502)
$PAGINATE
;$ERRONLY


CoincidenceDebugAidEnable	equ	0

	 %INCLUDE secseg.inc
	 %INCLUDE macro.inc
	 %include colorext.inc

asra	 %MACRO
	 cmp	  #$80
	 ror	  a
	 %ENDM


;	EXTERN	state,dfall

	EXTERN	Src(Page0),Dest(Page0),Ptr(Page0)
	EXTERN	Tmp(Page0),Tmp1(Page0),Tmp2(Page0)
	EXTERN	scan,column,colt,pixt,scanlo,scanhi
	EXTERN	rd_main,rd_aux,wr_main,wr_aux,ram_rd,ram_wr

	EXTERN	sp_xpos,sp_ypos,sp_colr,sp_flag,sp_poin
	EXTERN	Stkval
	EXTERN	hero_x,hero_y,HeadFlag,Facing
	EXTERN	Invert_Flag,Invert
	EXTERN	Stamp,Prim,Column,Scan
	EXTERN	jumpto, prmsec

	EXTERN	primlo,primhi,primys,primxs

	 extern   beastie_flag

	 extern   click,tone,noise

	 extern   NETFLT1R
	 extern   NETFLT2R
	 extern   NETFLT3R
	 extern   NETFLT4R
	 extern   NETFLT5R
	 extern   NETEMG4R
	 extern   NETOPN1R
	 extern   NETOPN2R
	 extern   NETEMG1L
	 extern   NETEMG2L
	 extern   NETEMG3L
	 extern   NETEMG3R
	 extern   NETEMG1R
	 extern   NETCLO4R
	 extern   NETEMG2R
	 extern   NETCLO1
	 extern   NETCLO0
	 extern   NETCLO4L
	 extern   NETCLO3
	 extern   NETCLO2
	 extern   NETOPNL
	 extern   NETOPNR
	 extern   NETFLT1L
	 extern   NETFLT2L
	 extern   NETFLT3L
	 extern   NETFLT4L
	 extern   NETFLT5L
	 extern   NETEMG4L
	 extern   NETOPN1L
	 extern   NETOPN2L
	 extern   BOTSHOTL
	 extern   BOTSHOTU
	 extern   BOTSHOTR

	EXTERN	Net_X,Net_Y,NetPhase,NetImageIndex,NetAngle
	EXTERN	NetDirection,BoltPhase,Bolt_X,Bolt_Y

	extern	  net_adjust_for_hero_movement

	 extern   norm

;Note: Bolt_X is the save variable as Net_X.
;Note: Bolt_Y is the save variable as Net_Y.

	SEG	Graph

	PUBLIC	NetManager,BoltManager
	PUBLIC	ClrPseudoScreen, CheckBackground, ClrScreenEdges
	PUBLIC	WinningScreen, DisplayStampedStuff


	 SEG	GRAPH

NetSprite	equ	7

NetManager	PROC
;
;This routine takes care of the net.				12-Apr-88  HES
;
;  The net has six phases:
;      FF = No Net.
;      80 = disabled
;	0 = Coming Out.
;	1 = Climbing and Fluttering.
;	2 = Top of Climb.
;	3 = Opening.
;	4 = Falling.
;	5 = Closing.
;
	lda	HeadFlag		;Is he a droid?
	beq	..ItsOkBecauseHesADroid ;Go if yes.
	jmp	..End			; otherwise, get out of here.

..ItsOkBecauseHesADroid
	lda	NetPhase
	bpl	..WeAlreadyGotOne	;..'e says he's already got one!
	cmp	  #$80
	lbeq	  ..end999

	lda	Stkval			;Is he trying to shoot a net?

	and	#$C0
	bne	..CreateANet		; Continue if yes.
	jmp	..End999		; Goto End if no.

..CreateANet
	lda	facing
	beq	..ck_stick
	cmp	  #$04
	lbne	..end999

..ck_stick
	lda	  stkval
	and	  #$02
	lbne	  ..end999

	lda	#0			;Start a net in Phase 0,
	sta	NetPhase		; and Phase 0's image #0.
	sta	NetImageIndex
	sta	beastie_flag

****************************
*  rich unruh mod	   *
;	lda	Stkval			;Set the flag for the angle.
;	and	#$01			; 2 = regular.
;	asl	  a
;	clc
;	adc	#2
;	sta	NetAngle

	lda	Stkval			;Set the flag for the angle.
	and	#$01			; 2 = regular.
	asl	  a
	clc
	adc	#1
	sta	NetAngle

*  rich unruh mod	   *
****************************

	lda	Facing			;Set up a variable to tell
	sec				; whether the net is going
	sbc	#$03			; left or right.
	and	#$80			; $00 = Right.
	sta	NetDirection		; $80 = Left.

	lda	hero_x			;Set up the net to start out at
	sta	  rd_main
	clc
	adc	  net_adjust_for_hero_movement
	sta	Net_X			; an offset from the hero's
	lda	hero_y			; coords.
	sec
	sbc	#42
	sta	Net_Y
	lda	NetDirection
	ora	#yellow 		;Get the color for the net,


	sta	wr_aux
	sta	sp_colr+(NetSprite*6)	; and set the color.
	sta	sp_colr+(NetSprite*6)+6
	lda	#$E6			;Set the 'Not Inverted' flag.
	sta	sp_flag+(NetSprite*6)
	lda	#0			;Disable the 2nd net sprite.
	sta	sp_flag+(NetSprite*6)+6
	sta	wr_main

..WeAlreadyGotOne			;Oh yes-a,...it's-a very nice-a...
	ldx	NetPhase	;Process a net in process:
	lda	..NetHandlerLo,x	;Get the addr of the processor
	sta	..NetVector		; routine and put it in the
	lda	..NetHandlerHi,x	; vector.
	sta	..NetVector+1
	jmp	(..NetVector)		;Jmp to the routine.

..NetVector	ds	2

..NetHandlerLo
	db     low(..Phase0)		; Handle a net coming out.
	db     low(..Phase1)		; Handle a net climb and flutter.
	db     low(..Phase2)		; Handle a net at the top of climb.
	db     low(..Phase3)		; Handle a net opening.
	db     low(..Phase4)		; Handle a net falling.
	db     low(..Phase5)		; Handle a net closing

..NetHandlerHi
	db     high(..Phase0)		; Handle a net coming out.
	db     high(..Phase1)		; Handle a net climb and flutter.
	db     high(..Phase2)		; Handle a net at the top of climb.
	db     high(..Phase3)		; Handle a net opening.
	db     high(..Phase4)		; Handle a net falling.
	db     high(..Phase5)		; Handle a net closing


..Phase0			;Coming Out:
	ldx	NetImageIndex		;Do the coord offset.
****************************
*  rich unruh mod	   *

;	lda	Net_X			;Start with the present X coord...

	 lda	  hero_x
	sta	  rd_main
	clc
	adc	  net_adjust_for_hero_movement

*  rich unruh mod	   *
****************************
	ldy	NetDirection
	bpl	..Right0		;Is net moving left?

	sec
	sbc	..Phase0XOffset,x	; If so, subt the image offset...
	jmp	..MovedX0

..Right0
	clc
	adc	..Phase0XOffset,x	; If not, add the image offset...

..MovedX0
	sta	Net_X			; and put it back as the new X coord.

	lda	Net_Y			;Start with the present Y coord...
	clc
	adc	..Phase0YOffset,x	; add on the image offset...
	sta	Net_Y			; and put it back as the new Y coord.

	lda	..Phase0ImageLo,x	;Set up the ptr to the image.

	sta	wr_aux
	sta	sp_poin+(NetSprite*6)
	lda	..Phase0ImageHi,x
	sta	sp_poin+(NetSprite*6)+1
	sta	wr_main

	inx				;Goto the next image number.
	stx	NetImageIndex
	cpx	#4			;Is Phase #0 done?
	bcs	..NextPhase		; Goto next phase is yes.

	txa
	asl	  a
	asl	  a
	asl	  a
	asl	  a
	tay
	ldx	  #$40
	jsr	  noise

	jmp	..End			; Goto end if no.


..NextPhase			;This goes to the next phase.
	ldx	NetPhase		;Get the present net phase.
	inx				;Goto the next net phase.
	cpx	#6			;Are we done?
	bcc	..StoreThePhase 	; Go if no.

	ldx	#$FF			;Set the phase to $FF is yes.
	lda	#$00			;Get rid of the net sprite.

	sta	wr_aux
	sta	sp_flag+(NetSprite*6)
	sta	wr_main

..StoreThePhase
	stx	NetPhase

	lda	#0			;Start with the 1st image.
	sta	NetImageIndex
	jmp	..End


..Phase1
	lda	Stkval			;Is the button still pressed?
	and	#$C0			; Go if no,
	beq	..NextPhase		; else stay here.

	ldx	#$40
	ldy	#$30
	jsr	  noise

	ldx	NetImageIndex
	lda	Net_X			;Get the present X coord...
	ldy	NetDirection
	bpl	..Right1		;Is net moving left?

	sec
	sbc	..Phase1XOffset,x	; If so, subt the image offset...
****************************
*  rich unruh mod	   *
	sbc	  #$02
*  rich unruh mod	   *
****************************
	jmp	..MovedX1

..Right1
	clc
****************************
*  rich unruh mod	   *
	adc	  #$02
*  rich unruh mod	   *
****************************
	adc	..Phase1XOffset,x	; If not, add the image offset...

..MovedX1
	sta	Net_X			; and put it back as the new X coord.

****************************
*  rich unruh mod	   *
	lda	Net_Y			;Start with the present Y coord...
	clc
	adc	..Phase1YOffset,x	; add the offset for this image...
	sec
	sbc	NetAngle		; and subt the amount for shot angle.
	sta	Net_Y			;Store the result as the Y coord.

*  rich unruh mod	   *
****************************




	lda	..Phase1ImageLo,x	;Set up the ptr to the image.

	sta	wr_aux
	sta	sp_poin+(NetSprite*6)
	lda	..Phase1ImageHi,x
	sta	sp_poin+(NetSprite*6)+1
	sta	wr_main

	inx				;Goto the next image number.
	stx	NetImageIndex
	cpx	#5			;Is Phase #1 done?
	bcc	..SameAsEnd		; Go if no.

	lda	#0			;Re-cycle through these images.
	sta	NetImageIndex
..SameAsEnd
	jmp	..End


..Phase2			;Top of Climb.
	ldx	NetImageIndex		;Do the coord offset.
	lda	Net_X			;Start with the present X coord...
	ldy	NetDirection
	bpl	..Right2		;Is net moving left?

	sec
	sbc	..Phase2XOffset,x	; If so, subt the image offset...
	jmp	..MovedX2

..Right2
	clc
	adc	..Phase2XOffset,x	; If not, add the image offset...

..MovedX2
	sta	Net_X			; and put it back as the new X coord.

	lda	Net_Y			;Start with the present Y coord...
	clc
	adc	..Phase2YOffset,x	; add on the image offset...
	sta	Net_Y			; and put it back as the new Y coord.

	lda	..Phase2ImageLo,x	;Set up the ptr to the image.

	sta	wr_aux
	sta	sp_poin+(NetSprite*6)
	lda	..Phase2ImageHi,x
	sta	sp_poin+(NetSprite*6)+1
	sta	wr_main

	inx				;Goto the next image number.
	stx	NetImageIndex
	cpx	#2			;Is Phase #2 done?
	bcc	..SameAsEnd		;Goto the End if no.
	jmp	..NextPhase		;Goto the next Phase if yes.


..Phase3			;Opening.
	ldx	NetImageIndex		;Do the coord offset.
	lda	Net_X			;Start with the present X coord...
	ldy	NetDirection
	bpl	..Right3		;Is net moving left?

	sec
	sbc	..Phase3XOffset,x	; If so, subt the image offset...
	jmp	..MovedX3

..Right3
	clc
	adc	..Phase3XOffset,x	; If not, add the image offset...

..MovedX3
	sta	Net_X			; and put it back as the new X coord.

	lda	Net_Y			;Start with the present Y coord...
	clc
	adc	..Phase3YOffset,x	; add on the image offset...
	sta	Net_Y			; and put it back as the new Y coord.

	lda	..Phase3ImageALo,x	;Set up the ptr to the image.

	sta	wr_aux
	sta	sp_poin+(NetSprite*6)
	lda	..Phase3ImageAHi,x
	sta	sp_poin+(NetSprite*6)+1
	sta	wr_main

	lda	NetImageIndex		;Does this image use both sprites?
	cmp	#2			; Go if no.
	bcc	..SkipDoing2ndSprite3

	lda	#$E6			;Enable the 2nd net sprite.

	sta	wr_aux
	sta	sp_flag+(NetSprite*6)+6

	lda	..Phase3ImageBLo,x	 ;Set up the ptr to the image.
	sta	sp_poin+(NetSprite*6)+6
	lda	..Phase3ImageBHi,x
	sta	sp_poin+(NetSprite*6)+7
	sta	wr_main

..SkipDoing2ndSprite3
	inx				;Goto the next image number.
	stx	NetImageIndex
	cpx	#3			;Is Phase #3 done?
	bcc	..End			;Goto the End if no.
	jmp	..NextPhase		;Goto the next Phase if yes.


..Phase4			;Falling.
	lda	Net_Y			;Get the Y coord...
	clc
	adc	#4			; add 4 to it...
	sta	Net_Y			; and put it back.

	adc	  #30
	cmp	#124+30 		;Is it below scan line 150?
	bcc	..End			; Goto the end if no.
	jmp	..NextPhase		; Goto the next phase if yes.


..Phase5			;Closing.
	ldx	NetImageIndex		;Do the coord offset.
	lda	Net_X			;Start with the present X coord...
	ldy	NetDirection
	bpl	..Right5		;Is net moving left?

	sec
	sbc	..Phase5XOffset,x	; If so, subt the image offset...
	jmp	..MovedX5

..Right5
	clc
	adc	..Phase5XOffset,x	; If not, add the image offset...

..MovedX5
	sta	Net_X			; and put it back as the new X coord.

	lda	Net_Y			;Start with the present Y coord...
	clc
	adc	..Phase5YOffset,x	; add on the image offset...
	sta	Net_Y			; and put it back as the new Y coord.

	lda	..Phase5ImageALo,x	 ;Set up the ptr to the image.

	sta	wr_aux
	sta	sp_poin+(NetSprite*6)
	lda	..Phase5ImageAHi,x
	sta	sp_poin+(NetSprite*6)+1

	lda	..Phase5ImageBLo,x	 ;Set up the ptr to the image.
	sta	sp_poin+(NetSprite*6)+6
	lda	..Phase5ImageBHi,x
	sta	sp_poin+(NetSprite*6)+7
	sta	wr_main

	lda	NetImageIndex		;Does this image use both sprites?
	beq	..SkipDoing2ndSprite5	; Go if yes.

	lda	#$00			;Disable the 2nd net sprite.

	sta	wr_aux
	sta	sp_flag+(NetSprite*6)+6
	sta	wr_main

..SkipDoing2ndSprite5

	inx				;Goto the next image number.
	stx	NetImageIndex
	cpx	#5			;Is Phase #5 done?
	bcc	..End			;Goto the End if no.
	jmp	..NextPhase		;Goto the next Phase if yes.


..End				;Handle exiting the net manager.
	lda	Net_X			;Is net off right edge of screen?
	cmp	#$a2			; Go if yes.
	bcs	..GetRidOfNet

	cmp	#$16			;Is net off left edge of screen?
	bcc	..GetRidOfNet		; Go if yes.

	lda	Net_Y			;Is net off top of screen?

****************************
*  rich unruh mod	   *
	clc
	adc	#20
*  rich unruh mod	   *
****************************

	cmp	#10			; Go if yes.
	bcc	..GetRidOfNet
	cmp	  #180
	bcs	..GetRidOfNet

	ldx	NetPhase		;Get the centering offset
	lda	Net_X			; for this phase and apply
	sec				; it to the X coord.
	sbc	..NetCenteringOffset,x

	ldx	NetDirection		;Is the net moving left?
	bpl	..End02 		; Go if no.

	sta	rd_aux
	ldx	sp_flag+(NetSprite*6)+6 ;Are we centering TWO sprites?
	sta	rd_main

	beq	..End01 		; Go if no.

	clc				;Add additional offset to center
	adc	#7			; two net sprites.
..End01
	sta	wr_aux
	sta	sp_xpos+(NetSprite*6)	;Put result into 1st sprite's X coord.
	sta	wr_main

	sec				;Put result-14 into 2nd sprite's
	sbc	#14			; X coord.
	jmp	..End04

..End02 				;The net is going right.
	sta	rd_aux
	ldx	sp_flag+(NetSprite*6)+6 ;Are we centering TWO sprites?
	sta	rd_main

	beq	..End03 		; Go if no.

	sec				;Subt additional offset to center
	sbc	#7			; two net sprites.
..End03
	sta	wr_aux
	sta	sp_xpos+(NetSprite*6)	;Put result into 1st sprite's X coord.
	sta	wr_main

	clc				;Put result+14 into 2nd sprite's
	adc	#14			; X coord.
..End04

	sta	wr_aux
	sta	sp_xpos+(NetSprite*6)+6 ;Set the Y coords.

	lda	Net_Y
	sta	sp_ypos+(NetSprite*6)
	sta	sp_ypos+(NetSprite*6)+6
	sta	wr_main

	jmp	..End999

..GetRidOfNet
	lda	#$FF			;Flag net as non-existent.
	sta	NetPhase
	lda	#0			;Flag sprites as unused.

	sta	wr_aux
	sta	sp_flag+(NetSprite*6)
	sta	sp_flag+(NetSprite*6)+6
	sta	wr_main

..End999
	rts

..NetCenteringOffset
	db	8,8,8,8,8,8

..Phase0ImageLo
	db	low(NetEmg1r)
	db	low(NetEmg2r)
	db	low(NetEmg3r)
	db	low(NetEmg4r)

..Phase0ImageHi
	db	high(NetEmg1r)
	db	high(NetEmg2r)
	db	high(NetEmg3r)
	db	high(NetEmg4r)

..Phase0XOffset
	db	9,9,9,9

..Phase0YOffset
	db	-3,-3,-4,-3


..Phase1ImageLo
	db	low(NetFlt1r)
	db	low(NetFlt2r)
	db	low(NetFlt3r)
	db	low(NetFlt4r)
	db	low(NetFlt5r)

..Phase1ImageHi
	db	high(NetFlt1r)
	db	high(NetFlt2r)
	db	high(NetFlt3r)
	db	high(NetFlt4r)
	db	high(NetFlt5r)

..Phase1XOffset
	db	1,2,1,1,1

..Phase1YOffset
	db	-1,-2,-3,-1,-1


..Phase2ImageLo
	db	low(NetOpn1r)
	db	low(NetOpn2r)

..Phase2ImageHi
	db	high(NetOpn1r)
	db	high(NetOpn2r)

..Phase2XOffset
	db	1,1

..Phase2YOffset
	db	0,0

..Phase3ImageALo
	db	low(NetClo2)
	db	low(NetClo3)
	db	low(NetClo4l)
	db	low(NetOpnl)

..Phase3ImageAHi
	db	high(NetClo2)
	db	high(NetClo3)
	db	high(NetClo4l)
	db	high(NetOpnl)

..Phase3ImageBLo
	db	0
	db	0
	db	low(NetClo4r)
	db	low(NetOpnr)

..Phase3ImageBHi
	db	0
	db	0
	db	high(NetClo4r)
	db	high(NetOpnr)

..Phase3XOffset
	db	0,0,0,0

..Phase3YOffset
	db	0,0,0,0

..Phase5ImageALo
	db	low(NetClo4l)
	db	low(NetClo3)
	db	low(NetClo2)
	db	low(NetClo1)
	db	low(NetClo0)

..Phase5ImageAHi
	db	high(NetClo4l)
	db	high(NetClo3)
	db	high(NetClo2)
	db	high(NetClo1)
	db	high(NetClo0)

..Phase5ImageBLo
	db	low(NetClo4r)
	db	0
	db	0
	db	0
	db	0

..Phase5ImageBHi
	db	high(NetClo4r)
	db	0
	db	0
	db	0
	db	0

..Phase5XOffset
	db	0,0,0,0,0

..Phase5YOffset
	db	0,0,0,0,0

NetManager	ENDPROC

BoltSprite	equ	7

BoltManager	PROC					;13-Apr-88  HES
;
; This routine takes care of the bolts.
;
;  The variable BoltPhase has three specific values:
;	$FF = No Bolt.
;	$00 = Bolt is traveling up.
;	$01 = Bolt is traveling down.
;
	lda	HeadFlag		;Is he a bot?
	cmp	#5
	beq	..ItsOkBecauseHesABot	;Go if yes.
	jmp	..End			; otherwise, get out of here.

..ItsOkBecauseHesABot
	lda	BoltPhase
	bpl	..WeAlreadyGotOne	;..'e says he's already got one!

	lda	Stkval			;Is he trying to shoot a bolt?

	and	#$C0
	bne	..CreateABolt		; Continue if yes.
	jmp	..getridofbolt		; Goto End if no.

..CreateABolt
	lda	  stkval
	and	  #$02
	lbne	  ..end

	lda	hero_x			;Set up the bolt's initial X coord.
	sec
	sbc	#2
	ldx	Facing			;Which way is Bot facing?
	beq	..InitBoltOnLeft	; Go if he's facing Left.
	cmp	#2
	beq	..StoreInitXCoord	; Go if he's facing the center.

..InitBoltOnRight
	clc				;Add to the bolt's X coord to
	adc	#5			; initialize bolt in front of barrel.
	jmp	..StoreInitXCoord

..InitBoltOnLeft
	clc				;Add to the bolt's X coord to
	adc	#2			; initialize bolt in front of barrel.

..StoreInitXCoord
	sta	Bolt_X

	lda	hero_y			;Set up the bolt's initial Y coord.
	ldy	#0			;Find 'BoltPhase' at the same time.
	ldx	Invert_Flag
	cpx	#Invert 		;Is Bot inverted?
	beq	..HeroIsInverted	; Go if no.
..HeroIsNotInverted
	sec				;Subt from the bolt's Y coord to
	sbc	#$22			; initialize bolt in front of barrel.
	jmp	..StoreInitYCoord

..HeroIsInverted
	clc				;Add to the bolt's Y coord to
	adc	#$1E			; initialize bolt in front of barrel.
	iny				;Note that bolt is UpSide Down.

..StoreInitYCoord
	sta	Bolt_Y			;Store initial Y coord.
	sty	BoltPhase		;Store 'BoltPhase'.

	lda	#l_blue 		; Set the color for the bolt.

	sta	wr_aux
	sta	sp_colr+(BoltSprite*6)
	sta	wr_main

	 ldx	  #$10
	 ldy	  #$c0
	 jsr	  tone

..WeAlreadyGotOne		;Process an existing bolt.
	ldy	#20			;Amount it moves in Y direction
	lda	Bolt_X			; if it's moving in X direction.
	ldx	Facing
	cpx	#$02
	bcs	..ItsNotMovingLeft


	lda	#-14			;Amount it moves in X direction
					; if it's moving left.
	sta	wr_aux
	ldx	#low(BotShotL)
	stx	sp_poin+(BoltSprite*6)
	ldx	#high(BotShotL)
	stx	sp_poin+(BoltSprite*6)+1
	sta	wr_main

	jmp	..DoneWithMovingX

..ItsNotMovingLeft
	cpx	#2
	bne	..ItsMovingRight

	ldy	#22			;Amount it moves in Y direction
					; if it's not moving in X direction.
	 lda	  #$00


	sta	wr_aux
	ldx	#low(BotShotU)
	stx	sp_poin+(BoltSprite*6)
	ldx	#high(BotShotU)
	stx	sp_poin+(BoltSprite*6)+1
	sta	wr_main

	jmp	..DoneWithMovingX

..ItsMovingRight
	lda	#14			;Amount it moves in X direction
					; if it's moving right.
	sta	wr_aux
	ldx	#low(BotShotR)
	stx	sp_poin+(BoltSprite*6)
	ldx	#high(BotShotR)
	stx	sp_poin+(BoltSprite*6)+1
	sta	wr_main

..DoneWithMovingX
	sta	..delta_x

	tya
	ldx	#$C6			;Set the 'Inverted' flag.

	sta	wr_aux
	stx	sp_flag+(BoltSprite*6)
	sta	wr_main

	clc
	ldx	BoltPhase
	bne	..ItsNotMovingUp

	ldx	#$E6			;Set the 'Not Inverted' flag.

	sta	wr_aux
	stx	sp_flag+(BoltSprite*6)
	sta	wr_main

	eor	#$FF
	clc
	adc	  #$01

..ItsNotMovingUp
	sta	..delta_y

	lda	Bolt_X			;save centered X coord.
	sec
	sbc	#4
	sta	..temp_x

	lda	bolt_y
	clc
	adc	#9
	sta	..Temp_y		;Save centered Y coord.

	sta	rd_main
	sta	wr_main



	 lda	  ..delta_x
	 asra
	 asra
	 sta	  ..temp_delta_x
	 clc
	 adc	  ..temp_x
	 sta	  column

	 lda	  ..delta_y
	 asra
	 asra
	 sta	  ..temp_delta_y
	 clc
	 adc	  ..temp_y
	 sta	  scan


	jsr	CheckBackground 	;Check the Pseudoscreen.
	cmp	#$20			;Is there air there?
	beq	..bounce_ck_2		; If no, make bolt bounce.

	 jsr	  ..set_coords_and_deltas

	 jmp	  ..makeitbounce



..bounce_ck_2
	 lda	  ..delta_x
	 asra
	 sta	  ..temp_delta_x
	 clc
	 adc	  ..temp_x
	 sta	  column

	 lda	  ..delta_y
	 asra
	 sta	  ..temp_delta_y
	 clc
	 adc	  ..temp_y
	 sta	  scan

	jsr	CheckBackground 	;Check the Pseudoscreen.
	cmp	#$20			;Is there air there?
	beq	..bounce_ck_3

	 jsr	  ..set_coords_and_deltas

	 jmp	  ..MakeItBounce


..bounce_ck_3
	 lda	  ..delta_x
	 asra
	 tax
	 lda	  ..temp_delta_x
	 asra
	 asra
	 sta	  ..temp_delta_x
	 txa
	 clc
	 adc	  ..temp_delta_x
	 sta	  ..temp_delta_x
	 adc	  ..temp_x
	 sta	  column

	 lda	  ..delta_y
	 asra
	 tax
	 lda	  ..temp_delta_y
	 asra
	 asra
	 sta	  ..temp_delta_y
	 txa
	 clc
	 adc	  ..temp_delta_y
	 sta	  ..temp_delta_y
	 adc	  ..temp_y
	 sta	  scan

	jsr	CheckBackground 	;Check the Pseudoscreen.
	cmp	#$20			;Is there air there?
	beq	..bounce_ck_4

	 jsr	  ..set_coords_and_deltas

	 jmp	  ..makeitbounce

..bounce_ck_4
	 lda	  ..temp_x
	 clc
	 adc	  ..delta_x
	 sta	  column

	 lda	  ..temp_y
	 clc
	 adc	  ..delta_y
	 sta	  scan

	jsr	CheckBackground 	;Check the Pseudoscreen.
	cmp	#$20			;Is there air there?
	beq	..DontMakeItBounce	; If yes, don't make bolt bounce.

..MakeItBounce
	lda	Facing			;If the bolt is moving up or down,
	cmp	#2			; instead of making it bounce,
	beq	..GetRidOfBolt		;  get rid it.

	lda	BoltPhase		; Otherwise, make it bounce.
	eor	#$01
	sta	BoltPhase

	beq	..it_will_be_going_up
	lda	  #invert
	bne	  ..store_bolt_flag
..it_will_be_going_up
	 lda	  #norm
..store_bolt_flag
	sta	wr_aux
	sta	sp_flag+(BoltSprite*6)
	sta	wr_main



	 lda	  ..delta_y
	 eor	  #$ff
	 tax
	 inx
	 stx	  ..delta_y

..DontMakeItBounce
	 lda	  bolt_x
	 clc
	 adc	  ..delta_x
	 sta	  bolt_x

	 lda	  bolt_y
	 clc
	 adc	  ..delta_y
	 sta	  bolt_y


	lda	Bolt_X
	cmp	#150
	bcs	..GetRidOfBolt

	cmp	#31
	bcc	..GetRidOfBolt

	lda	Bolt_Y
	cmp	#160
	bcs	..GetRidOfBolt

	cmp	#10
	bcs	..SetSpriteCoords

..GetRidOfBolt
	lda	#$FF
	sta	BoltPhase
	lda	#0

	sta	wr_aux
	sta	sp_flag+(BoltSprite*6)
	sta	wr_main

..SetSpriteCoords
	lda	Bolt_X
	sec
	sbc	#8

	sta	wr_aux
	sta	sp_xpos+(BoltSprite*6)
	lda	Bolt_Y
	sta	sp_ypos+(BoltSprite*6)
	sta	wr_main

..End
	rts


..set_coords_and_deltas
	 lda	  column
	 clc
	 adc	  #$04
	 sta	  bolt_x

	 lda	  scan
	 sec
	 sbc	  #$09
	 sta	  bolt_y

	 lda	  ..delta_x
	 sec
	 sbc	  ..temp_delta_x
	 sta	  ..delta_x

	 lda	  ..delta_y
	 sec
	 sbc	  ..temp_delta_y
	 sta	  ..delta_y

	 rts



..Temp_y	  ds	   1
..temp_x	  ds	   1

..delta_x	  ds	   1
..delta_y	  ds	   1

..temp_delta_x	  ds	   1
..temp_delta_y	  ds	   1



BoltManager	ENDPROC

DisplayStampedStuff	PROC
;
; This routine displays stuff the Stamper stamped to the Erase Screen.
;
; PASS (The same stuff you just passed to the Stamper):
;	Prim	- the primitive number you just stamped
;	Column	- the X-coord you stamped it at.
;	Scan	- the Y-coord you stamped it at.
;
	lda	ram_rd		;See which memory is enabled
	sta	..Lookie	; and save this info.

	sta	rd_main
	sta	wr_main

	ldx	prim			;Get the X-size of this prim.
	lda	primxs,x
	clc
	adc	column			;Add it to the column to find
	tay				; where we should end x-wise

	sta	rd_aux
	lda	colt+21,y		; in terms of pixels.
	sta	rd_main

	clc				;Look this up in COLT to find
	adc	#2			; where we should end in bytes.
	sta	..LastX

	lda	primys,x		;Get the Y-size of this prim.
	sec				; (Add one for good measure.)
	adc	scan			;Add it to the scan to find
	sta	..LastY 		; where we should end y-wise

..Loop1
	ldx	scan

	sta	rd_aux
	lda	scanlo-4,x
	sta	tmp
	sta	dest
	sta	ptr
	lda	scanhi-4,x
	sta	rd_main

	cpx	#$04
	bcs	  ..normal_offsets

	sta	tmp+1			;TMP points to buffer area.
	sta	dest+1			;DEST points to buffer area.
	sta	ptr+1			;PTR points to buffer area.
	jmp	..after_patch1

..normal_offsets
	ora	#$60
	sta	tmp+1			;TMP points to Erase Screen.
	eor	#$40
	sta	dest+1			;DEST points to Screen One.
	eor	#$60
	sta	ptr+1			;PTR points to Screen Two.

..after_patch1
	ldx	column

	sta	rd_aux
	ldy	colt+21,x
	sta	rd_main

..Loop2
	sta	rd_aux
	sta	wr_aux

	lda	(tmp),y 		;Copy the byte in Aux Memory.
	sta	(dest),y
	sta	(ptr),y

	sta	rd_main
	sta	wr_main

	lda	(tmp),y 		;Copy the byte in Main Memory.
	sta	(dest),y
	sta	(ptr),y
	iny				;Goto the next byte.
	cpy	..LastX 		;Are we done with this scan line?
	bcc	..Loop2 		; Loop back if no.

	inc	scan			;Goto the next scan line.
	lda	scan
	cmp	..LastY 		;Are we done with all scan lines?
	bcc	..Loop1 		; Loop back if no.

	ldx	..Lookie	;Was Aux memory enabled when we were called?
	bpl	..End		;Go if no (because Main is enabled now).
	sta	rd_aux		;Enable Aux memory.
	sta	wr_aux
..End
	rts

..LastX 	ds	1
..LastY 	ds	1
..Lookie	ds	1

DisplayStampedStuff	ENDPROC


WinningScreen	PROC						;15-Apr-88  HES
;
; This routine prints up the winning screen.
;
	lda	#0		;Handle the series of 'Spiderbot's on the
	sta	..XCoord	; left edge of the screen.
	sta	..YCoord
	lda	#21
	sta	..Count
..Loop1
	lda	#74
	ldx	..XCoord
	ldy	..YCoord

	sta	rd_main
	sta	wr_main
	sta	Prim
	stx	Column
	sty	Scan

	jsr	stamp

;	lda	#low(stamp)
;	sta	jumpto
;	lda	#high(stamp)
;	sta	jumpto+1
;	JSR	prmsec

	jsr	DisplayStampedStuff
	sta	rd_aux
	sta	wr_aux

	lda	..YCoord
	clc
	adc	#8
	sta	..YCoord

	dec	..Count
	bne	..Loop1

	lda	#5			;Print 4 of them angling towards
	sta	..Count 		; the center of the screen.
..Loop2
	lda	#74
	ldx	..XCoord
	ldy	..YCoord

	sta	rd_main
	sta	wr_main
	sta	Prim
	stx	Column
	sty	Scan

	jsr	stamp

;	lda	#low(stamp)
;	sta	jumpto
;	lda	#high(stamp)
;	sta	jumpto+1
;	JSR	prmsec

	jsr	DisplayStampedStuff
	sta	rd_aux
	sta	wr_aux

	lda	..XCoord
	clc
	adc	#8
	sta	..XCoord

	lda	..YCoord
	sec
	sbc	#8
	sta	..YCoord

	dec	..Count
	bne	..Loop2

	lda	#24*3+4 	;Handle the series of 'Spiderbot's on the
	sta	..XCoord	; right edge of the screen.
	lda	#0
	sta	..YCoord
	lda	#21
	sta	..Count
..Loop3
	lda	#74
	ldx	..XCoord
	ldy	..YCoord

	sta	rd_main
	sta	wr_main
	sta	Prim
	stx	Column
	sty	Scan

	jsr	stamp

;	lda	#low(stamp)
;	sta	jumpto
;	lda	#high(stamp)
;	sta	jumpto+1
;	JSR	prmsec

	jsr	DisplayStampedStuff
	sta	rd_aux
	sta	wr_aux

	lda	..YCoord
	clc
	adc	#8
	sta	..YCoord

	dec	..Count
	bne	..Loop3

	lda	#5			;Print 4 of them angling towards
	sta	..Count 		; the center of the screen.
..Loop4
	lda	#74
	ldx	..XCoord
	ldy	..YCoord

	sta	rd_main
	sta	wr_main
	sta	Prim
	stx	Column
	sty	Scan

	jsr	stamp

;	lda	#low(stamp)
;	sta	jumpto
;	lda	#high(stamp)
;	sta	jumpto+1
;	JSR	prmsec

	jsr	DisplayStampedStuff
	sta	rd_aux
	sta	wr_aux

	lda	..XCoord
	sec
	sbc	#8
	sta	..XCoord

	lda	..YCoord
	sec
	sbc	#8
	sta	..YCoord

	dec	..Count
	bne	..Loop4

	lda	#12*3+3 	;Handle the series of 'Spiderbot's down
	sta	..XCoord	; the center of the screen.
	lda	#0
	sta	..YCoord
	lda	#17
	sta	..Count
..Loop5
	lda	#74
	ldx	..XCoord
	ldy	..YCoord

	sta	rd_main
	sta	wr_main
	sta	Prim
	stx	Column
	sty	Scan

	jsr	stamp

;	lda	#low(stamp)
;	sta	jumpto
;	lda	#high(stamp)
;	sta	jumpto+1
;	JSR	prmsec

	jsr	DisplayStampedStuff
	sta	rd_aux
	sta	wr_aux

	lda	..YCoord
	clc
	adc	#8
	sta	..YCoord

	dec	..Count
	bne	..Loop5

	sta	rd_main
	sta	wr_main

	rts

..XCoord	ds	1
..YCoord	ds	1
..Count 	ds	1

WinningScreen	ENDPROC


CheckBackground PROC

;
; This routine does the coincidence detection of the background.
;  It checks the specified pixel and one on either side.
;
;	PASS:	column	- the xcoord of the pixel to check (0-139).
;		scan	- the ycoord of the pixel to check (0-191).
;
;	RETURNS:A	- $20 = That area is in the air.
;			  $A0 = You can walk on that area.
;			  $C0 = You can't walk through that area.
;
	lda	ram_rd		;See which memory is enabled
	sta	tmp		; and save this info.

	ldy	scan	;This section takes care of the y-offset.
	cpy	#$04
	bcc	..nogoodrtu
	cpy	#196		;kam mod  5-9-88
	bcc	..kamskiphereandnow
..nogoodrtu
	lda	  #$20
	jmp	..End
..kamskiphereandnow


	%If (CoincidenceDebugAidEnable ne 0)
	 lda	 dest	 ;DEBUG.
	 sta	 ..Ha	 ;DEBUG
	 lda	 dest+1  ;DEBUG.
	 sta	 ..Ha+1  ;DEBUG

	 lda	  #$00
	 sta	  ..special_stuff

	%Endif


****************************
*   RICH UNRUH PATCH	   *

;	sta	rd_aux
;	lda	scanlo,y
;	sta	ptr
;	sta	dest
;	lda	scanhi,y
;	sta	rd_main
;
;	ora	#$60		;TMP1 holds high byte of
;	sta	tmp1		; the Erase Screen address.



	sta	rd_aux

	lda	scanlo,y
	sta	ptr
	lda	scanhi,y
	and	#$03		;PTR points to the
	ora	#$04		; Pseudo-Screen.
	sta	ptr+1


	lda	scanlo-4,y
	sta	..rtu_ptr
	sta	dest
	lda	scanhi-4,y
	ora	#$60		;..rtu_ptr holds high byte of
	sta	..rtu_ptr+1	; the Erase Screen address.

	sta	rd_main


*   RICH UNRUH PATCH	   *
****************************


	%If (CoincidenceDebugAidEnable ne 0)
	 and	 #$1f	 ;DEBUG.
	 ora	 #$20	 ;DEBUG.
	 sta	 dest+1  ;DEBUG.
	%Endif


	lda	column	;This section takes care of the x-offset.
	sec
	sbc	#21

	cmp	#3		;Is column < 3?
	bcc	..ItsNegative	; Go if yes.
	cmp	#198		;Is Column < 0? (198 = 140+(256-140)/2)
	bcs	..ItsNegative	; Go if yes.
	cmp	#136		;Is Column > 136?
	bcc	..ItsOK 	; Go if no.

	lda	#135		;We're making 135 the max.
	jmp	..ItsOK

..ItsNegative
	lda	#3		;We're making 2 the min.

..ItsOK
	tax		;Find the index along this scan line.
	sta	rd_aux
	ldy	colt+21,x
	lda	pixt+21,x
	tax			;Save the pixel number in X.
	sta	rd_main

	cmp	#3		;If pixel >= 3,
	bcc	..label1	; Then check the byte at Y+1.
	iny			; Else check the byte at Y.
	lda	(ptr),y
	dey
	jmp	..label2
..label1
	lda	(ptr),y 	;The pseudo-screen value is in A.
..label2
	cmp	#$C0		;Is there a Borer wall there?
	bne	..Label3	;If not, continue.

	%If (CoincidenceDebugAidEnable ne 0)
	 sta	  ..special_stuff
	 jmp	  ..label5
	%Endif

	jmp	..DontCheckPixels  ;If so, jump to end.

..label3
	cmp	#$B0		;Is there foliage there?
	bne	..label4	;If not, continue.
	lda	#$A0		;Signal that something's there

	%If (CoincidenceDebugAidEnable ne 0)
	 sta	  ..special_stuff
	 jmp	  ..label5
	%Endif

	jmp	..DontCheckPixels	; and goto the end.

..label4
	cmp	#$20		;Is there nothing there?
	bne	..label5	;If not, continue.

	%If (CoincidenceDebugAidEnable ne 0)
	 sta	  ..special_stuff
	 jmp	  ..label5
	%Endif

	jmp	..DontCheckPixels	; else goto the end.

..label5

****************************
*   RICH UNRUH PATCH	   *

;	lda	tmp1		;Set up PTR to point at
;	sta	ptr+1		; Erase Screen.

	 lda	  ..rtu_ptr
	 sta	  ptr
	 lda	  ..rtu_ptr+1
	 sta	  ptr+1


*   RICH UNRUH PATCH	   *
****************************


	dey
	lda	(ptr),y 	;Get the byte at Main(Y-1).
	and	MaskForByte0,x	;AND with the mask for this pixel.
				; (Remember X holds the pixel number.)
	sta	tmp1		;TMP1 will be our running total

	%If (CoincidenceDebugAidEnable ne 0)
	 sta	 wr_main	 ;DEBUG.
	 lda	 #$ff		 ;DEBUG.
	 and	 MaskForByte0,x  ;DEBUG.
	 ora	 (dest),y	 ;DEBUG.
	 sta	 (dest),y	 ;DEBUG.
	%Endif

	iny
	lda	(ptr),y 	;Get the byte at Main(Y).
	and	MaskForByte2,x	;AND with the mask for this pixel.
	ora	tmp1		;OR this with the running total.
	sta	tmp1		;Store result into running total.

	%If (CoincidenceDebugAidEnable ne 0)
	 lda	 #$ff		 ;DEBUG.
	 and	 MaskForByte2,x  ;DEBUG.
	 ora	 (dest),y	 ;DEBUG.
	 sta	 (dest),y	 ;DEBUG.
	%Endif

	iny
	lda	(ptr),y 	;Get the byte at Main(Y+1).
	and	MaskForByte4,x	;(Same as above lines...)
	ora	tmp1
	sta	tmp1

	%If (CoincidenceDebugAidEnable ne 0)
	 lda	 #$ff		 ;DEBUG.
	 and	 MaskForByte4,x  ;DEBUG.
	 ora	 (dest),y	 ;DEBUG.
	 sta	 (dest),y	 ;DEBUG.
	%Endif

	iny
	sta	rd_aux		;Switch to read Auxilliary memory.
	lda	(ptr),y 	;Get the byte at Aux(Y+2)
	and	MaskForByte5,x
	ora	tmp1
	sta	tmp1

	%If (CoincidenceDebugAidEnable ne 0)
	 sta	 wr_aux 	 ;DEBUG.
	 lda	 #$ff		 ;DEBUG.
	 and	 MaskForByte5,x  ;DEBUG.
	 ora	 (dest),y	 ;DEBUG.
	 sta	 (dest),y	 ;DEBUG.
	%Endif

	dey
	lda	(ptr),y 	;Get the byte at Aux(Y+1).
	and	MaskForByte3,x
	ora	tmp1
	sta	tmp1

	%If (CoincidenceDebugAidEnable ne 0)
	 lda	 #$ff		 ;DEBUG.
	 and	 MaskForByte3,x  ;DEBUG.
	 ora	 (dest),y	 ;DEBUG.
	 sta	 (dest),y	 ;DEBUG.
	%Endif

	dey
	lda	(ptr),y 	;Get the byte at Aux(Y).
	and	MaskForByte1,x
	ora	tmp1

	%If (CoincidenceDebugAidEnable ne 0)
	 lda	 #$ff		 ;DEBUG.
	 and	 MaskForByte1,x  ;DEBUG.
	 ora	 (dest),y	 ;DEBUG.
	 sta	 (dest),y	 ;DEBUG.
	 lda	 tmp1		 ;DEBUG.
	%Endif

	tay			;Put answer in Y.
	lda	#$20		;Return a $20 if they're off.
	cpy	#0
	beq	..DontCheckPixels
	lda	#$A0		;Return a $A0 if they're on.

..DontCheckPixels
	sta	rd_main
	sta	wr_main

	%If (CoincidenceDebugAidEnable ne 0)
	 pha		 ;DEBUG.
	 lda	 ..Ha	 ;DEBUG.
	 sta	 dest	 ;DEBUG.
	 lda	 ..Ha+1  ;DEBUG.
	 sta	 dest+1  ;DEBUG.
	 pla		 ;DEBUG.
	%Endif

	%If (CoincidenceDebugAidEnable ne 0)
	 ldx	  ..special_stuff
	 beq	  ..endofspecialstuff
	 txa
..endofspecialstuff
	%Endif


	ldx	tmp		;Was Aux memory enabled when we were called?
	bpl	..End		;Go if no (because Main is enabled now).

	sta	rd_aux		;Enable Aux memory.
	sta	wr_aux
..End
	rts


****************************
*   RICH UNRUH PATCH	   *

..rtu_ptr	  ds	   2

*   RICH UNRUH PATCH	   *
****************************


	%If (CoincidenceDebugAidEnable ne 0)
..Ha	 db	 0,0
..special_stuff   ds	   1
	%Endif

CheckBackground ENDPROC

;	SEG	MAINDATA

MaskForByte0   db      $78,$00,$00,$00,$00,$00,$00
MaskForByte1   db      $7F,$7F,$70,$00,$00,$00,$00
MaskForByte2   db      $01,$1F,$7F,$7E,$60,$00,$00
MaskForByte3   db      $00,$00,$03,$3F,$7F,$7C,$40
MaskForByte4   db      $00,$00,$00,$00,$07,$7F,$7F
MaskForByte5   db      $00,$00,$00,$00,$00,$00,$0F

;Mask	 db	 $78,$7F,$01,$00,$00,$00
;Mask	 db	 $00,$7F,$1F,$00,$00,$00
;Mask	 db	 $00,$70,$7F,$03,$00,$00
;Mask	 db	 $00,$00,$7E,$3F,$00,$00
;Mask	 db	 $00,$00,$60,$7F,$07,$00
;Mask	 db	 $00,$00,$00,$7C,$7F,$00
;Mask	 db	 $00,$00,$00,$40,$7F,$0F


ClrScreenEdges	PROC					;08-Mar-88  HES

;
; This routine erases one pixel from either side of the screen.
; This works on the Erase Screen and lets the natural
;  course of events copy the changes to the Work Screens.
; It also sets up the mask screen so that sprites won't be
;  displayed there, either.  (..Happy now, Unruh??)
;
	ldx	#191		;Do 192 scan lines worth.
..Loop
	sta	rd_aux
	sta	wr_aux

	lda	scanlo,x	;Get the address of this scan line.
	sta	dest
	sta	ptr
	lda	scanhi,x
	ora	#$60		;Dest will point at
	sta	dest+1		; the Erase Screen.
	and	#$1f
	ora	#$80		;Ptr will point at
	sta	ptr+1		; the Mask screen.

; These two writes are to Aux Memory.
	ldy	#0		;Trash the 1st pixel.
	lda	(dest),y
	and	#$00
	sta	(dest),y

	ldy	#39		;Trash the 2nd-to-last pixel.
	lda	(dest),y
	and	#$07
	sta	(dest),y

;These two writes are also to Aux Memory.
	ldy	#0
	lda	(ptr),y
	and	#$7C		;$7E
	sta	(ptr),y 	;Alter the mask on the left.
	ldy	#38
	lda	(ptr),y
	and	#$1F		;$3F
	sta	(ptr),y 	;Alter the mask on the right.

	sta	rd_main
	sta	wr_main

;These two writes are to Main Memory
	iny
	lda	(dest),y	;Trash the last pixel.
	and	#$00
	sta	(dest),y

	ldy	#0		;Trash the 2nd pixel.
	lda	(dest),y
	and	#$60
	sta	(dest),y

	dex			;Dec the scan line counter.
	cpx	#$ff		;Are we done?
	bne	..Loop		;If no, loop back.

	rts

ClrScreenEdges	ENDPROC


ClrPseudoScreen PROC

;
; Clr the Pseudo Screen to be all $20 (Inverse Space).
;

	lda	#$20
	ldy	#0
..loop
	sta	$0400,y
	sta	$0500,y
	sta	$0600,y
	sta	$07d0+$28-$0100,y
	dey
	bne	..loop
	rts

ClrPseudoScreen ENDPROC
	 END
